// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "xkeymacs.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define WM_USER_NTFYICON (WM_USER+100)

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(IDC_ABOUT, OnAbout)
	ON_COMMAND(IDC_QUIT, OnQuit)
	ON_COMMAND(IDC_DISABLE, OnDisable)
	ON_COMMAND(IDC_PROPERTIES, OnProperties)
	ON_COMMAND(IDC_OPTIONS, OnOptions)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here

	m_pXkeymacsDll			= new CXkeymacsDll;
	m_pXkeymacsDlg			= new CXkeymacsDlg;
	m_nResultXkeymacsDlg	= -1;
	m_bXkeymacsDlgExist		= FALSE;
	m_pAboutDlg				= new CAboutDlg;
	m_nResultAboutDlg		= -1;
	m_bAboutDlgExist		= FALSE;
	m_pOptionsDlg			= new COptionsDlg;
	m_nResultOptionsDlg		= -1;
	m_bOptionsDlgExist		= FALSE;

	// register window class
	WNDCLASS	stWndClass;
	CString szClassName;
	szClassName.LoadString(AFX_IDS_APP_TITLE);
	CString szWindowName;
	szWindowName.LoadString(AFX_IDS_APP_TITLE);

	stWndClass.style			= CS_BYTEALIGNWINDOW;
	stWndClass.lpfnWndProc		= &AfxWndProc;
	stWndClass.cbClsExtra		= 0;
	stWndClass.cbWndExtra		= 0;
	stWndClass.hInstance		= AfxGetInstanceHandle();
	stWndClass.hIcon			= NULL;
	stWndClass.hCursor			= NULL;
	stWndClass.hbrBackground	= (HBRUSH)COLOR_BACKGROUND;
	stWndClass.lpszMenuName		= NULL;
	stWndClass.lpszClassName	= szClassName;

	AfxRegisterClass(&stWndClass);

	// make window
	CRect	rect(0, 0, 100, 100);

	Create(szClassName, szWindowName, WS_OVERLAPPEDWINDOW | WS_MINIMIZE, rect);
}

CMainFrame::~CMainFrame()
{
	delete m_pXkeymacsDll;
	delete m_pXkeymacsDlg;
	delete m_pAboutDlg;
	delete m_pOptionsDlg;
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// display icon in task tray
	m_stNtfyIcon.cbSize				= sizeof(NOTIFYICONDATA);
	m_stNtfyIcon.uID				= 0;
	m_stNtfyIcon.hWnd				= m_hWnd;
	m_stNtfyIcon.uFlags				= NIF_MESSAGE | NIF_ICON | NIF_TIP;
	m_stNtfyIcon.hIcon				= AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_stNtfyIcon.uCallbackMessage	= WM_USER_NTFYICON;
	LoadString(AfxGetInstanceHandle(), AFX_IDS_APP_TITLE, m_stNtfyIcon.szTip, sizeof(m_stNtfyIcon.szTip));
	::Shell_NotifyIcon(NIM_ADD, &m_stNtfyIcon);

	m_pXkeymacsDll->SetKeyboardHook();

	return 0;
}

//DEL BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
//DEL {
//DEL 	if (!CFrameWnd::PreCreateWindow(cs))
//DEL 		return FALSE;
//DEL 	// TODO: Modify the Window class or styles here by modifying
//DEL 	//  the CREATESTRUCT cs
//DEL 
//DEL 	return TRUE;
//DEL }

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::SetForegroundTheDialog(CDialog *pDialog)
{
	if (pDialog)
		pDialog->SetForegroundWindow();
}

void CMainFrame::SetForegroundSomeDialog()
{
	CDialog *pDialog = NULL;

	if (m_bXkeymacsDlgExist)
		pDialog = m_pXkeymacsDlg;
	else if (m_bOptionsDlgExist)
		pDialog = m_pOptionsDlg;
	else if (m_bAboutDlgExist)
		pDialog = m_pAboutDlg;
	else {
		EnableWindow(FALSE);
		return;
	}

	SetForegroundTheDialog(pDialog);
	return;
}

void CMainFrame::PopUpDialog(CDialog *pDialog, int *pnResultDialog, BOOL *pbDialogExist)
{
	if (pDialog			== NULL ||
		pnResultDialog	== NULL ||
		pbDialogExist	== NULL)
		return;

	if (!*pbDialogExist) {
		*pbDialogExist = TRUE;
		*pnResultDialog = pDialog->DoModal();
		*pbDialogExist = FALSE;
		*pnResultDialog = -1;

		SetForegroundSomeDialog();
	} else {
		SetForegroundTheDialog(pDialog);
	}
}

void CMainFrame::PopUpPropertiesDialog()
{
	PopUpDialog(m_pXkeymacsDlg, &m_nResultXkeymacsDlg, &m_bXkeymacsDlgExist);
}

// show right menu on icon in system tray
void CMainFrame::ShowRightMenu()
{
	CMenu rightMenu;
	rightMenu.LoadMenu(IDR_RIGHT_MENU);

	CMenu *popUp = rightMenu.GetSubMenu(0);

	popUp->SetDefaultItem(IDC_PROPERTIES);

	CString szDisable;
	if (m_pXkeymacsDll->IsKeyboardHook()) {
		szDisable.LoadString(IDS_DISABLE);
	} else {
		szDisable.LoadString(IDS_ENABLE);
	}
	CString szApplicationName;
	szApplicationName.LoadString(AFX_IDS_APP_TITLE);
	CString szDisableMessage;
	szDisableMessage.Format(szDisable, szApplicationName);
	popUp->ModifyMenu(IDC_DISABLE, MF_STRING, IDC_DISABLE, szDisableMessage);

	SetForegroundWindow();

	CPoint pt;
	GetCursorPos(&pt);
	popUp->TrackPopupMenu(TPM_RIGHTBUTTON, pt.x, pt.y, this);
}

// get message of icon on system tray
LRESULT CMainFrame::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	static UINT s_uTaskbarRestart;

	switch (message) {
	case WM_CREATE:
		s_uTaskbarRestart = RegisterWindowMessage(TEXT("TaskbarCreated"));
		break;
	case WM_USER_NTFYICON:
		switch (lParam) {
		case WM_LBUTTONUP:
			SetForegroundSomeDialog();
			break;
		case WM_LBUTTONDBLCLK:
			PopUpPropertiesDialog();
			break;
		case WM_RBUTTONUP:
			ShowRightMenu();
			break;
		default:
			break;
		}
	default:
		if(message == s_uTaskbarRestart)
			::Shell_NotifyIcon(NIM_ADD, &m_stNtfyIcon);
		break;
	}
	
	return CFrameWnd::WindowProc(message, wParam, lParam);
}

void CMainFrame::OnProperties()
{
	PopUpPropertiesDialog();
}

void CMainFrame::PopUpOptionsDialog()
{
	PopUpDialog(m_pOptionsDlg, &m_nResultOptionsDlg, &m_bOptionsDlgExist);
}

void CMainFrame::OnOptions() 
{
	// TODO: Add your command handler code here
	PopUpOptionsDialog();
}

// stop/start keyboard hook
void CMainFrame::OnDisable() 
{
	// TODO: Add your command handler code here
	if (m_pXkeymacsDll->IsKeyboardHook()) {
		m_pXkeymacsDll->ReleaseKeyboardHook();
		m_stNtfyIcon.hIcon = AfxGetApp()->LoadIcon(IDR_STOP);
	} else {
		m_pXkeymacsDll->SetKeyboardHook();
		m_stNtfyIcon.hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	}
	::Shell_NotifyIcon(NIM_MODIFY, &m_stNtfyIcon);
}

// Close the Dialog if it is opened.
void CMainFrame::CloseDialog(CDialog *pDialog, int *pnResult)
{
	if (*pnResult != -1) {
		pDialog->EndDialog(*pnResult);
		*pnResult = -1;
	}
}

void CMainFrame::OnQuit() 
{
	// TODO: Add your command handler code here
	CloseDialog(m_pAboutDlg, &m_nResultAboutDlg);
	CloseDialog(m_pXkeymacsDlg, &m_nResultXkeymacsDlg);
	CloseDialog(m_pOptionsDlg, &m_nResultOptionsDlg);

	m_pXkeymacsDll->ReleaseKeyboardHook();

	::Shell_NotifyIcon(NIM_DELETE, &m_stNtfyIcon);
	PostQuitMessage(0);
}

void CMainFrame::PopUpAboutDialog()
{
	PopUpDialog(m_pAboutDlg, &m_nResultAboutDlg, &m_bAboutDlgExist);
}

void CMainFrame::OnAbout() 
{
	// TODO: Add your command handler code here
	PopUpAboutDialog();
}

BOOL CMainFrame::XkeymacsDialogExist()
{
	return m_nResultXkeymacsDlg != -1;
}
