// xkeymacsdll.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "../xkeymacs/resource.h"
#include <afxdllx.h>
#include <math.h>
#include <Imm.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable: 4100)	// unreferenced formal parameter

static AFX_EXTENSION_MODULE XkeymacsdllDLL = { NULL, NULL };

static HINSTANCE g_hDllInst = NULL;

HINSTANCE GetThisHInst()
{
	return g_hDllInst;
}

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	g_hDllInst = hInstance;

	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("XKEYMACSDLL.DLL Initializing!\n");

		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(XkeymacsdllDLL, hInstance))
			return 0;

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		new CDynLinkLibrary(XkeymacsdllDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("XKEYMACSDLL.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(XkeymacsdllDLL);
	}
	return 1;   // ok
}

//////////////////////////////////////////////////////////////////////
// CXkeymacsDll Class
//////////////////////////////////////////////////////////////////////

#include "xkeymacsDll.h"
#pragma data_seg(".xkeymacs")
	HHOOK	CXkeymacsDll::m_hHookKeyboard = NULL;
	HHOOK	CXkeymacsDll::m_hHookCallWnd = NULL;
	int		CXkeymacsDll::m_nEnable[MAX_APP][MAX_COMMAND_TYPE][MAX_KEY] = {'\0'};
	char	CXkeymacsDll::m_szSpecialApp[MAX_APP][CLASS_NAME_LENGTH] = {'\0'};
	BOOL	CXkeymacsDll::m_bOriginal[MAX_KEY][KEY_TRANSITION] = {'\0'};	// ignore shift in command type
	HWND	CXkeymacsDll::m_hPrevWnd = 0;
	OSVERSIONINFO CXkeymacsDll::m_OsVersionInfo;
	SearchDirection CXkeymacsDll::m_CurrentDirection = NA;
	BOOL	CXkeymacsDll::m_bControl		= FALSE;
	BOOL	CXkeymacsDll::m_bRightControl	= FALSE;
	BOOL	CXkeymacsDll::m_bAlt			= FALSE;
	BOOL	CXkeymacsDll::m_bRightAlt		= FALSE;
	BOOL	CXkeymacsDll::m_bMeta			= FALSE;
	BOOL	CXkeymacsDll::m_bShift			= FALSE;
	BOOL	CXkeymacsDll::m_bRightShift		= FALSE;
	BOOL	CXkeymacsDll::m_bImeComposition	= FALSE;
	BOOL	CXkeymacsDll::m_bC_x			= FALSE;
	BOOL	CXkeymacsDll::m_bM_				= FALSE;
	BOOL	CXkeymacsDll::m_bJack			= FALSE;
	int		CXkeymacsDll::m_nRepeat			= 0;
#pragma data_seg()

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXkeymacsDll::CXkeymacsDll()
{
	memset(m_bOriginal, 0, sizeof(m_bOriginal));
}

CXkeymacsDll::~CXkeymacsDll()
{

}


// set keyboard hook
BOOL CXkeymacsDll::SetKeyboardHook()
{
	m_hHookKeyboard = ::SetWindowsHookEx(WH_KEYBOARD, (HOOKPROC)KeyboardProc, GetThisHInst(), 0);
	if(!m_hHookKeyboard)
		return FALSE;

	m_hHookCallWnd = ::SetWindowsHookEx(WH_CALLWNDPROC, (HOOKPROC)CallWndProc, GetThisHInst(), 0);
//	if(!m_hHookCallWnd)
//		return FALSE;

	return TRUE;
}

// release keyboard hook
BOOL CXkeymacsDll::ReleaseKeyboardHook()
{
	BOOL bKeyboard = TRUE;
	BOOL bCallWnd = TRUE;

	if(m_hHookKeyboard)
		bKeyboard = ::UnhookWindowsHookEx(m_hHookKeyboard);
	m_hHookKeyboard = NULL;

	if(m_hHookCallWnd)
		bCallWnd = ::UnhookWindowsHookEx(m_hHookCallWnd);
	m_hHookCallWnd = NULL;

	return bKeyboard && bCallWnd;
}

// if be keyboard hook, return TRUE
BOOL CXkeymacsDll::IsKeyboardHook()
{
	if (m_hHookKeyboard)
		return TRUE;

	return FALSE;
}

LRESULT CALLBACK CXkeymacsDll::CallWndProc(int code, WPARAM wParam, LPARAM lParam)
{
	if (0 <= code) {
		CWPSTRUCT &cwps = *(CWPSTRUCT *)lParam;
		switch (cwps.message) {
		case WM_IME_STARTCOMPOSITION:
			m_bImeComposition = TRUE;
			break;
		case WM_IME_ENDCOMPOSITION:
			m_bImeComposition = FALSE;
			break;
		}
	}
	return CallNextHookEx(m_hHookCallWnd, code, wParam, lParam);
}

// return true if the key is down
inline BOOL CXkeymacsDll::IsDown(BYTE bVk)
{
	return (GetKeyState(bVk) < 0);
}

// Do keybd_event
void CXkeymacsDll::DoKeybd_event(BYTE bVk, DWORD dwFlags, LPARAM lParam)
{
	// Set KEYEVENTF_EXTENDEDKEY if needed
	switch (bVk) {
	case VK_CONTROL:
		if (m_bRightControl)	// Right Ctrl
			dwFlags |= KEYEVENTF_EXTENDEDKEY;
		break;

	case VK_MENU:
		if (m_bRightAlt)		// Right Alt
			dwFlags |= KEYEVENTF_EXTENDEDKEY;
		break;

	case VK_SHIFT:
		if (m_bRightShift)		// Right Shift
			dwFlags |= KEYEVENTF_EXTENDEDKEY;
		break;

	case VK_PAUSE:
		if (m_bControl || IsDown(VK_CONTROL))	// Break
			dwFlags |= KEYEVENTF_EXTENDEDKEY;
		break;

	case VK_INSERT:
	case VK_DELETE:
	case VK_HOME:
	case VK_END:
	case VK_NEXT:
	case VK_PRIOR:
	case VK_UP:
	case VK_DOWN:
	case VK_RIGHT:
	case VK_LEFT:
	case VK_NUMLOCK:
	case VK_PRINT:
		dwFlags |= KEYEVENTF_EXTENDEDKEY;
		break;

	default:
		break;
	}

	if (dwFlags & KEYEVENTF_KEYUP)
		m_bOriginal[bVk][KEY_UP] = TRUE;
	else
		m_bOriginal[bVk][KEY_DOWN] = TRUE;

	keybd_event(bVk, MapVirtualKey(bVk, 0), dwFlags, lParam);
}

// the key is being depressed
inline void CXkeymacsDll::DepressKey(BYTE bVk, LPARAM lParam = 0)	// bVk is virtual-key code, MSDN said
{
	DoKeybd_event(bVk, 0, lParam);
}

// the key is being released
inline void CXkeymacsDll::ReleaseKey(BYTE bVk, LPARAM lParam = 0)	// bVk is virtual-key code, MSDN said
{
	DoKeybd_event(bVk, KEYEVENTF_KEYUP, lParam);
}

// bVk down, bVk up
inline void CXkeymacsDll::Kdu(BYTE bVk, int n = 1)
{
	if (n == 0)
		n = 1;
	while (n--) {
		DepressKey(bVk);
		ReleaseKey(bVk);
	}
}

void CXkeymacsDll::Kdoru(BYTE bVk, LPARAM lParam, int n = 1)
{
	if (lParam & TRANSITION) {
		ReleaseKey(bVk, lParam);
	} else {
		if (n != 0)
			while (--n)
				Kdu(bVk, 0);
		DepressKey(bVk, lParam);
	}
}

// if control is down: control up, atl down, bVk down, bVk up, alt up, control down
inline void CXkeymacsDll::AdKduAu(BYTE bVk)
{
	DepressKey(VK_MENU);
	Kdu(bVk);
	ReleaseKey(VK_MENU);
}

// if control is down: control up, atl down, bVk1 down, bVk1 up, bVk2 down, bVk2 up, alt up, control down
inline void CXkeymacsDll::AdKduKduAu(BYTE bVk1, BYTE bVk2)
{
	DepressKey(VK_MENU);
	Kdu(bVk1);
	Kdu(bVk2);
	ReleaseKey(VK_MENU);
}

// if control is down: control up, atl down, bVk1 down, bVk1 up, ...,  bVk3 down, bVk3 up, alt up, control down
inline void CXkeymacsDll::AdKduKduKduAu(BYTE bVk1, BYTE bVk2, BYTE bVk3)
{
	DepressKey(VK_MENU);
	Kdu(bVk1);
	Kdu(bVk2);
	Kdu(bVk3);
	ReleaseKey(VK_MENU);
}

// control up, shift down, bVk down, bVk up, shift up, control down
inline void CXkeymacsDll::SdKduSu(BYTE bVk)
{
	DepressKey(VK_SHIFT);
	Kdu(bVk);
	ReleaseKey(VK_SHIFT);
}

// control up, shift down, bVk1 down, bVk1 up, bVk2 down, bVk2 up, shift up, control down
inline void CXkeymacsDll::SdKduKduSu(BYTE bVk1, BYTE bVk2)
{
	DepressKey(VK_SHIFT);
	Kdu(bVk1);
	Kdu(bVk2);
	ReleaseKey(VK_SHIFT);
}

void CXkeymacsDll::CdKdoruCu(BYTE bVk, LPARAM lParam, int n = 1)
{
	if (!(lParam & TRANSITION))
		DepressKey(VK_CONTROL);

	Kdoru(bVk, lParam, n);

	if (lParam & TRANSITION)
		ReleaseKey(VK_CONTROL);
}

// alt up, control down, bVk down, bVk up, control up, alt down
inline void CXkeymacsDll::CdKduCu(BYTE bVk, int n = 1)
{
	BYTE ks[256];

	GetKeyboardState( ks );
	ks[ VK_CONTROL ] = 1;
	SetKeyboardState( ks );

	DepressKey(VK_CONTROL);
	Kdu(bVk, n);
	ReleaseKey(VK_CONTROL);

	GetKeyboardState( ks );
	ks[ VK_CONTROL ] = 0;
	SetKeyboardState( ks );
}

inline BOOL CXkeymacsDll::CopyBackCharacter()
{
	if (!OpenClipboard(NULL))
		return FALSE;
	if (!EmptyClipboard())
		return FALSE;
	if (!CloseClipboard())
		return FALSE;

	SdKduSu(VK_LEFT);
	CdKduCu('C');
	Kdu(VK_RIGHT);

	return TRUE;
}

// Copy next character of the cursor
inline BOOL CXkeymacsDll::CopyNextCharacter()
{
	if (!OpenClipboard(NULL))
		return FALSE;
	if (!EmptyClipboard())
		return FALSE;
	if (!CloseClipboard())
		return FALSE;

	SdKduSu(VK_RIGHT);
	CdKduCu('C');
	Kdu(VK_LEFT);

	return TRUE;
}

// control up, VK_KANJI down, VK_KANJI up, control down
inline void CXkeymacsDll::ToggleIME(char *szApplicationName, int nApplicationNameLength)
{
	if (!strnicmp(szApplicationName, "iexplore.exe", nApplicationNameLength) &&
		((5 <= m_OsVersionInfo.dwMajorVersion) && (1 <= m_OsVersionInfo.dwMinorVersion))) {
		// Windows XP + IE
		Kdu(VK_KANJI);
	} else {
		// default
		HWND hWnd = GetFocus();
		HIMC hIMC = ImmGetContext(hWnd);
		ImmSetOpenStatus(hIMC, !ImmGetOpenStatus(hIMC));
		ImmReleaseContext(hWnd, hIMC);
	}
}

CSearchKey::CSearchKey()
{
	m_bFindWhat				= 'N';
	m_bDirectionForward		= 'D';
	m_bDirectionBackward	= 'U';
	m_bSearchOption			= 0;
}

CSearchKey::CSearchKey(char *szApplicationName, int nApplicationNameLength, CString *szDialogTitle)
{
	m_bFindWhat				= 'N';
	m_bDirectionForward		= 'D';
	m_bDirectionBackward	= 'U';
	m_bSearchOption			= 0;

	if (!strnicmp(szApplicationName, "wordpad.exe", nApplicationNameLength) ||
		!strnicmp(szApplicationName, "123w.exe", nApplicationNameLength)) {
		m_bDirectionForward = m_bDirectionBackward = 0;
	} else if (!strnicmp(szApplicationName, "nlnotes.exe", nApplicationNameLength)) {
		// Lotus Notes
		m_bFindWhat				= 'F';
		m_bDirectionForward		= 'D';
		m_bDirectionBackward	= 'B';
		m_bSearchOption			= 'O';
	} else if (!strnicmp(szApplicationName, "b2.exe", nApplicationNameLength)) {
		// Becky!
		m_bFindWhat			= 'F';
		if (!szDialogTitle->Compare("{")) {
			m_bDirectionForward		= 'O';
			m_bDirectionBackward	= 'B';
		} else {
			m_bDirectionForward		= 0;
			m_bDirectionBackward	= 0;
		}
	} else if (!strnicmp(szApplicationName, "sakura.exe", nApplicationNameLength)) {
		m_bFindWhat				= 0;
		m_bDirectionForward		= 'D';
		m_bDirectionBackward	= 'U';
	} else if (!strnicmp(szApplicationName, "hidemaru.exe", nApplicationNameLength)) {
		m_bFindWhat				= 'S';
		m_bDirectionForward		= 'N';
		m_bDirectionBackward	= 'P';
	}

	if (!strnicmp(szApplicationName, "outlook.exe", nApplicationNameLength) &&
		!szDialogTitle->Compare("Find")) {
		// Outlook (English version)
		m_bDirectionForward = m_bDirectionBackward = 0;
	}
}

CSearch::CSearch(char* szApplicationName, int nApplicationNameLength)
{
	{
		char buf[0x100];
		memset(buf, 0, sizeof(buf));
		if (!strnicmp(szApplicationName, "b2.exe", nApplicationNameLength) ||
			!strnicmp(szApplicationName, "hidemaru.exe", nApplicationNameLength) ||
			!strnicmp(szApplicationName, "msdev.exe", nApplicationNameLength) ||
			!strnicmp(szApplicationName, "sakura.exe", nApplicationNameLength)) {
			// Becky!, hidemaru, VC++, sakura
			GetWindowText(GetParent(GetParent(GetFocus())), buf, sizeof(buf));

			// This it not use for hidemaru and sakura.
			// If use this, keyboard hook will be released.
//			AfxGetApp()->m_pMainWnd->GetFocus()->GetParent()->GetParent()->GetWindowText(szDialogTitle);
		} else {
			// default
			GetWindowText(GetParent(GetFocus()), buf, sizeof(buf));
//			AfxGetApp()->m_pMainWnd->GetFocus()->GetParent()->GetWindowText(szDialogTitle);
		}
		m_szDialogTitle.Format("%s", buf);
	}

//	CString sz;
//	sz.Format("A%sA", szDialogTitle);
//	AfxMessageBox(sz);
//	AfxMessageBox(szDialogTitle);

	if (!m_szDialogTitle.Compare("") ||				// notepad, wordpad, IE, regedit, 
														// Excel, Front Page, PowerPoint, Acrobat Reader, IBM HPB
		!m_szDialogTitle.Compare("Find") ||				// notepad, Outlook, Outlook Express, Opera
		!m_szDialogTitle.Compare("{") ||			// Becky!
		!m_szDialogTitle.Compare("[") ||			// Becky!
		!m_szDialogTitle.Compare("̌") ||		// M$ VC++
		!m_szDialogTitle.Compare("ƒu") ||			// M$ Word, 123
		!m_szDialogTitle.Compare("̃eLXǧ")	// Lotus Notes
		) {
//		AfxMessageBox("FALSE");
	} else {
		m_szDialogTitle.Empty();
//		AfxMessageBox("TRUE");
	}

	m_pKey = new CSearchKey(szApplicationName, nApplicationNameLength, &m_szDialogTitle);
}

inline void CXkeymacsDll::SearchSetDirection(SearchDirection direction, char *szApplicationName,
											 int nApplicationNameLength, CSearch *pSearch)
{
	if ((direction != FORWARD) && (direction != BACKWARD))
		ASSERT(0);

	if (pSearch->m_pKey->m_bDirectionForward == 0 && pSearch->m_pKey->m_bDirectionBackward == 0)
		return;
	else if (!strnicmp(szApplicationName, "winword.exe", nApplicationNameLength)) {
		// Microsoft Word
		AdKduAu('M');
		AdKduAu(VK_OEM_1);	// 0xBA Used for miscellaneous characters; it can vary by keyboard. 
								//		Windows 2000/XP: For the US standard keyboard, the ';:' key
		Kdu(VK_UP);
		Kdu(VK_UP);
		if (direction == BACKWARD)
			Kdu(VK_DOWN);
		AdKduAu('N');
		Kdu(VK_ESCAPE);
	} else if (!strnicmp(szApplicationName, "nlnotes.exe", nApplicationNameLength)) {
		// Lotus Notes
		BYTE bDirection	= 0;

		if (direction == FORWARD)
			bDirection = pSearch->m_pKey->m_bDirectionForward;
		else if (direction == BACKWARD)
			bDirection = pSearch->m_pKey->m_bDirectionBackward;

		AdKduKduKduAu(pSearch->m_pKey->m_bSearchOption, bDirection, pSearch->m_pKey->m_bSearchOption);
		SdKduKduSu(VK_TAB, VK_TAB);
		Kdu(VK_END);
	} else if (!strnicmp(szApplicationName, "b2.exe", nApplicationNameLength)) {
		// Becky!
		AdKduAu(pSearch->m_pKey->m_bDirectionForward);
		if (direction == BACKWARD)
			Kdu(VK_UP);
		Kdu(VK_TAB, 4);
		Kdu(VK_END);
	} else {
		// default
		BYTE bDirection	= 0;
	
		if (direction == FORWARD)
			bDirection = pSearch->m_pKey->m_bDirectionForward;
		else if (direction == BACKWARD)
			bDirection = pSearch->m_pKey->m_bDirectionBackward;

		AdKduKduAu(bDirection, pSearch->m_pKey->m_bFindWhat);
	}
}

inline void CXkeymacsDll::Search(SearchDirection direction, char *szApplicationName, int nApplicationNameLength)
{
	if ((direction != FORWARD) && (direction != BACKWARD))
		ASSERT(0);

	CSearch *pSearch;
	pSearch = new CSearch(szApplicationName, nApplicationNameLength);

	if (pSearch->m_szDialogTitle.IsEmpty()) {
		// Find Dialog is not.
		// Open Find dialog
		if ((!strnicmp(szApplicationName, "notepad.exe", nApplicationNameLength)) &&
			((m_OsVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS) ||
			 ((m_OsVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_NT) &&
			  (m_OsVersionInfo.dwMajorVersion <= 4)))) {
			// notepad on Win9x or NT
//			AdKduKduAu('S', 'F');
			AdKduAu('S');
			Kdu('F');
		} else if (!strnicmp(szApplicationName, "sakura.exe", nApplicationNameLength)) {
			// sakura
			AdKduKduAu('S', VK_RETURN);
		} else if (!strnicmp(szApplicationName, "msimn.exe", nApplicationNameLength)) {
			Kdu(VK_F3);
		} else if (!strnicmp(szApplicationName, "opera.exe", nApplicationNameLength) ||
				   !strnicmp(szApplicationName, "hidemaru.exe", nApplicationNameLength)) {

			CdKduCu('F');
		} else {
			// default
//			CdKduCu('F');
//			AdKduKduAu('E', 'F');
			AdKduAu('E');
			Kdu('F');
		}

		// Set Direction w/o with sakura.exe if Find dialog already exist
		if (!strnicmp(szApplicationName, "sakura.exe", nApplicationNameLength) ||
			!strnicmp(szApplicationName, "wordpro.exe", nApplicationNameLength) ||
			!strnicmp(szApplicationName, "hidemaru.exe", nApplicationNameLength)) {
			// sakura, wordpro
		} else if (!strnicmp(szApplicationName, "iexplore.exe", nApplicationNameLength)) {
			// IE
			// I want to set direction but IE does not allow me.
		} else {
			// default
//			SearchSetDirection(direction, szApplicationName, nApplicationNameLength,
//							   bOriginalM_b, bOriginalM_f, pSearch);
			SearchSetDirection(direction, szApplicationName, nApplicationNameLength, pSearch);
		}
		m_CurrentDirection = direction;
	} else {
		if (!strnicmp(szApplicationName, "sakura.exe", nApplicationNameLength) ||
			!strnicmp(szApplicationName, "hidemaru.exe", nApplicationNameLength)) {
			BYTE bDirection = 0;

			if (direction == FORWARD)
				bDirection = pSearch->m_pKey->m_bDirectionForward;
			else if (direction == BACKWARD)
				bDirection = pSearch->m_pKey->m_bDirectionBackward;
			else
				ASSERT(0);
			AdKduAu(bDirection);
		} else {
			if (m_CurrentDirection != direction) {
				// Set Direction if Find dialog already exist
//				SearchSetDirection(direction, szApplicationName, nApplicationNameLength,
//								   bOriginalM_b, bOriginalM_f, pSearch);
				SearchSetDirection(direction, szApplicationName, nApplicationNameLength, pSearch);
				m_CurrentDirection = direction;
				return;
			}

			// "Find Next(F)" if Find dialog already exist
			Kdu(VK_RETURN);

			// open Find dialog again
			if (!strnicmp(szApplicationName, "outlook.exe", nApplicationNameLength) &&
				pSearch->m_szDialogTitle.Compare("")) {
				// Outlook (w/o Japanese version)
//				AdKduKduAu('E', 'F');
				AdKduAu('E');
				Kdu('F');
			} else if (!strnicmp(szApplicationName, "msdev.exe", nApplicationNameLength)) {
				// Visual C++
				CdKduCu('F');
			} else if (!strnicmp(szApplicationName, "b2.exe", nApplicationNameLength)) {
				// Becky!
//				AdKduKduAu('E', 'F');
//				CdKduCu('F');
			}

			// set cursor at end of FindWhat
			if (!strnicmp(szApplicationName, "b2.exe", nApplicationNameLength)) {
//				Kdu(VK_TAB, 4);
//				Kdu(VK_DOWN);
			} else {
				AdKduAu(pSearch->m_pKey->m_bFindWhat);
				if(!strnicmp(szApplicationName, "winword.exe", nApplicationNameLength))
					Kdu(VK_ESCAPE);
			}
			Kdu(VK_END);
		}
	}
	delete pSearch;
}

// emulate emacs	// cf virtual-key code
LRESULT CALLBACK CXkeymacsDll::KeyboardProc(int code, WPARAM wParam, LPARAM lParam)
{
/** /
	{
		// Show key code
		CString sz;
		sz.Format("%c: 0x%x", wParam, wParam);
		AfxMessageBox(sz);
	}
/**/

	static BOOL bOldImeComposition	= FALSE;
//	static BOOL	bC_x		 = FALSE;
//	static BOOL bM_			 = FALSE;
//	static BOOL bOriginalC_f = FALSE;
//	static BOOL bOriginalC_o = FALSE;
//	static BOOL bOriginalC_v = FALSE;
//	static BOOL bOriginalC_x = FALSE;
//	static BOOL bOriginalC_z = FALSE;
//	static BOOL bOriginalM_b = FALSE;
//	static BOOL bOriginalM_f = FALSE;
//	static int	nRepeat		 = 0;
	HWND		hCurrentWnd = GetFocus();
	static char szApplicationName[MAX_PATH];
	static int	nApp = 0;
	int nCommandID = 0;
	static WPARAM wRecursiveCommand = 0;

	if (code < 0 || code == HC_NOREMOVE)
		goto DO_NOTHING;

//	if (lParam & TRANSITION)
//		goto DO_NOTHING;

	if ((m_hPrevWnd != hCurrentWnd) || (bOldImeComposition != m_bImeComposition)) {
		if (m_hPrevWnd != hCurrentWnd)
			m_bImeComposition = FALSE;

		CString szApplicationNameOrg = szApplicationName;
		memset(szApplicationName, 0, sizeof(szApplicationName));

		if (m_bImeComposition) {
			HKL hKL = GetKeyboardLayout(0);
			if (ImmIsIME(hKL)) {
				ImmGetIMEFileName(hKL, szApplicationName, sizeof(szApplicationName));
			} else {
				ASSERT(0);	// B'coz m_bImeComposition is TRUE;
			}
		} else {
			GetModuleFileName(NULL, szApplicationName, sizeof(szApplicationName));
			CString szFn(szApplicationName);
			szFn.Delete(0, szFn.ReverseFind('\\') + 1);
			ZeroMemory(szApplicationName, sizeof(szApplicationName));
			strncpy(szApplicationName, szFn, szFn.GetLength());
		}

		if (strnicmp(m_szSpecialApp[nApp], szApplicationName, sizeof(szApplicationName))) {
			for (nApp = 0; nApp < MAX_APP; nApp++) {
				if (!strnicmp(m_szSpecialApp[nApp], szApplicationName, sizeof(szApplicationName))) {
					break;
				}
			}
			if (nApp == MAX_APP) {
				for (nApp = 0; nApp < MAX_APP; nApp++) {
					CString szDefault(IDS_DEFAULT);	// Is it work correct??? Delete! Use only static function. i.e. do not use string resource
					if (!strnicmp(m_szSpecialApp[nApp], szDefault, sizeof(szApplicationName))) {
						break;
					}
				}
				if (nApp == MAX_APP)
					nApp = 0;
			}
		}

		m_hPrevWnd			= hCurrentWnd;
		bOldImeComposition	= m_bImeComposition;
		m_bC_x				= FALSE;
		m_bM_				= FALSE;
		m_nRepeat			= 0;

		m_OsVersionInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
		GetVersionEx(&m_OsVersionInfo);

		if (strcmp(szApplicationName, szApplicationNameOrg)) {
			m_CurrentDirection		= NA;
		}
	}

	{
		KeyTransition transition = (lParam & TRANSITION) ? KEY_UP : KEY_DOWN;
		if (m_bOriginal[wParam][transition] && (wRecursiveCommand != wParam)) {
			m_bOriginal[wParam][transition] = FALSE;
			goto DO_NOTHING;
		}
	}

	{
		static WPARAM wParamOriginal = 0;
		if (!m_bJack)
			wParamOriginal = wParam;
		if (m_bJack && (wParam == wParamOriginal) && (lParam & TRANSITION)) {
				m_bJack = FALSE;
			goto DO_NOTHING;
		}
	}

	if (wParam == VK_CONTROL) {
		m_bControl		= !(lParam & TRANSITION);
		m_bRightControl	= m_bControl && (lParam & EXTENDED_KEY);
	}
	if (wParam == VK_MENU) {
		m_bAlt			= !(lParam & TRANSITION);
		m_bRightAlt		= m_bAlt && (lParam & EXTENDED_KEY);
		m_bMeta			= IsMeta(nApp);
	}
	// This is NOT beautiful!!
	if (m_bM_)
		m_bMeta |= 2;
	else
		m_bMeta &= ~2;
	if (wParam == VK_SHIFT) {
		m_bShift		= !(lParam & TRANSITION);
		m_bRightShift	= m_bShift && (lParam & EXTENDED_KEY);
	}

	if (wParam == VK_MENU)
		goto DO_NOTHING;

//	if(!(lParam & (PREVIOUS | TRANSITION))) {
//		m_bControl		= IsDown(VK_CONTROL);
//		m_bRightControl	= IsDown(VK_RCONTROL);

//		m_bAlt			= IsDown(VK_MENU);
//		m_bRightAlt		= IsDown(VK_RMENU);
//		m_bMeta			= IsMeta(nApp);

//		m_bShift		= IsDown(VK_SHIFT);
//		m_bRightShift	= IsDown(VK_RSHIFT);
//	}

	if			( m_bC_x	&&  m_bControl				&&  m_bShift	&& m_nEnable[nApp][CONTROLX_CONTROL_SHIFT_FOO][wParam]) {
		nCommandID = m_nEnable[nApp][CONTROLX_CONTROL_SHIFT_FOO][wParam];
	} else if	( m_bC_x	&&  m_bControl				&& !m_bShift	&& m_nEnable[nApp][CONTROLX_CONTROL_FOO][wParam]) {
		nCommandID = m_nEnable[nApp][CONTROLX_CONTROL_FOO][wParam];
	} else if	( m_bC_x	&& !m_bControl				&&  m_bShift	&& m_nEnable[nApp][CONTROLX_SHIFT_FOO][wParam]) {
		nCommandID = m_nEnable[nApp][CONTROLX_SHIFT_FOO][wParam];
	} else if	( m_bC_x	&& !m_bControl				&& !m_bShift	&& m_nEnable[nApp][CONTROLX_FOO][wParam]) {
		nCommandID = m_nEnable[nApp][CONTROLX_FOO][wParam];
	} else if	(			    m_bControl				&&  m_bShift	&& m_nEnable[nApp][CONTROL_SHIFT_FOO][wParam]) {
		nCommandID = m_nEnable[nApp][CONTROL_SHIFT_FOO][wParam];
	} else if	(			    m_bControl				&& !m_bShift	&& m_nEnable[nApp][CONTROL_FOO][wParam]) {
		nCommandID = m_nEnable[nApp][CONTROL_FOO][wParam];
	} else if	(			   !m_bControl	&&  m_bMeta &&  m_bShift	&& m_nEnable[nApp][META_SHIFT_FOO][wParam]) {
		nCommandID = m_nEnable[nApp][META_SHIFT_FOO][wParam];
	} else if	(			   !m_bControl	&&  m_bMeta && !m_bShift	&& m_nEnable[nApp][META_FOO][wParam]) {
		nCommandID = m_nEnable[nApp][META_FOO][wParam];
	} else if	(			   !m_bControl				&&  m_bShift	&& m_nEnable[nApp][NONE_SHIFT_FOO][wParam]) {
		nCommandID = m_nEnable[nApp][NONE_SHIFT_FOO][wParam];
	} else if	(			   !m_bControl				&& !m_bShift	&& m_nEnable[nApp][NONE_FOO][wParam]) {
		nCommandID = m_nEnable[nApp][NONE_FOO][wParam];
	} else {
		if (!(lParam & TRANSITION))
			if (!nCommandID && m_nRepeat && !m_bControl && !m_bAlt) {
				Kdu((BYTE)wParam, m_nRepeat);
				goto HOOK;
			}

		goto DO_NOTHING;
	}

	if (!(lParam & (PREVIOUS | TRANSITION))) {
		if (m_bControl) {
			BYTE ks[MAX_KEY];

			GetKeyboardState( ks );
			ks[ VK_CONTROL ] = 0;
			SetKeyboardState( ks );

			ReleaseKey(VK_CONTROL);
		}

		if (m_bAlt) {
			ReleaseKey(VK_MENU);
		}

		if (m_bShift) {
			ReleaseKey(VK_SHIFT);
		}
	}

//	if (IsDown(VK_CONTROL)) {
//		if (m_bC_x) {
//			if (!m_nEnable[nApp][CONTROLX][wParam] && !m_nEnable[nApp][CONTROL][wParam]) {
//				goto DO_NOTHING;
//			} else if (!m_nEnable[nApp][CONTROLX][wParam]) {
//				m_bC_x = FALSE;
//			}
//		} else if (!m_nEnable[nApp][CONTROL][wParam]) {
//			goto DO_NOTHING;
//		}
//	} else if (IsMeta(nApp)) {
//		if (!m_nEnable[nApp][META][wParam])
//			goto DO_NOTHING;
//	} else {
//		if (!m_nEnable[nApp][NONE][wParam])
//			if (!m_nRepeat) {
//				goto DO_NOTHING;
//			} else {
//				ASSERT(0 <= wParam && wParam <= UCHAR_MAX);
//				Kdu((BYTE)wParam, m_nRepeat);
//				goto HOOK;
//			}
//	}

//	if (IsDown(VK_CONTROL)) {
//		switch (m_nEnable[nApp][CONTROL][wParam]) {
//		case IDS_NEWLINE:
//			CuKduCd(VK_RETURN, m_nRepeat);
//			goto HOOK;
//			break;
//		case IDS_SCROLL_DOWN:
//			CuKduCd(VK_PRIOR, m_nRepeat);
//			goto HOOK;
//			break;
//		}
//	}

	switch (DoCommand(nCommandID, lParam, szApplicationName)) {
	case RC_DO_NOTHING:
		goto DO_NOTHING;
		break;
	case RC_HOOK:
		goto HOOK;
		break;
	case RC_HOOK0_9:
		goto HOOK0_9;
		break;
	case RC_HOOKX:
		goto HOOKX;
		break;
	case RC_RECURSIVE:
		goto RECURSIVE;
		break;
	default:
		ASSERT(0);
		break;
	}
	ASSERT(0);

/*
	// C-?
	if (IsDown(VK_CONTROL)) {
		switch (wParam) {
		case 'A':
			// C-a: Home
			CuKduCd(VK_HOME);
			goto HOOK;

		case 'B':
			// C-b: Left
			CuKduCd(VK_LEFT, m_nRepeat);
			goto HOOK;

		case 'C':
			// C-x C-c: Alt-F4
			if (m_bC_x) {
				if (strnicmp(szApplicationName, "explorer.exe", sizeof(szApplicationName)))
					CuAdKduKduAuCd(VK_SPACE, 'C');
				else
					CuAdKduAuCd(VK_F4);
				goto HOOK;
			} else
				break;

		case 'D':
			// C-d: Delete
			CuKduCd(VK_DELETE, m_nRepeat);
			goto HOOK;

		case 'E':
			// C-e: End
			CuKduCd(VK_END);
			goto HOOK;

		case 'F':
			// C-x C-f: Alt-F, Alt-O
			if (m_bC_x) {
//				bOriginalM_f = TRUE;
				m_bOriginal[META_FOO]['F'] = TRUE;
				CuAdKduKduAuCd('F', 'O');
				goto HOOK;
			}

			// Ctrl-F: Find...
//			else if (bOriginalC_f) {
			else if (m_bOriginal[CONTROL_FOO]['F']) {
//				bOriginalC_f = FALSE;
				m_bOriginal[CONTROL_FOO]['F'] = FALSE;
				goto DO_NOTHING;
			}

			// C-f: Right		
			else {
				CuKduCd(VK_RIGHT, m_nRepeat);
				goto HOOK;
			}

		case 'G':
			// C-g: Keyboard quit
			goto HOOK;

		case 'H':
			// C-h: Back space
			CuKduCd(VK_BACK, m_nRepeat);
			goto HOOK;

		case 'I':
			// C-i: Tab
			CuKduCd(VK_TAB);
			goto HOOK;

		case 'J':
			// C-x C-j: Toggle IME
			if (m_bC_x) {
				ToggleIME(szApplicationName, sizeof(szApplicationName));
				goto HOOK;
			} else
				break;

		case 'K':
			// C-k: Shift-End, Shift-Delete, if the cursor is not at EOL (is End Of Line)
			//		Shift-Right, Cut, if the cursor is at EOL
			if (!strnicmp(szApplicationName, "123w.exe", sizeof(szApplicationName))) {
				// C-k: Shift-End, Control-x
				CuSdKduSuCd(VK_END);
				Kdu('W');
				goto HOOK;
			}

			{
				static CString szOriginalClipboardText;
				// Do not try to do these command at once.
				// Clipboard has old data till you go out this function.
				static int nStep = 0;
				static CString szClipboardText;

				switch (nStep) {
				case 0:
					szOriginalClipboardText.Empty();
					if (!GetClipboardText(&szOriginalClipboardText))
						szOriginalClipboardText.Empty();

					if (!CopyNextCharacter())
						goto DO_NOTHING;
					nStep = 1;
					goto RECURSIVE;
				case 1:
					nStep = 0;

					szClipboardText.Empty();
					GetClipboardText(&szClipboardText);

//					{
//						CString sz;
//						sz.Format("%x, %s", szClipboardText.GetAt(0), szClipboardText);
//						AfxMessageBox(sz);
//					}

					if (szClipboardText.IsEmpty()) {	// EOF
						if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName)) ||
							!strnicmp(szApplicationName, "frontpg.exe", sizeof(szApplicationName)) ||
							!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
							CuKduCd(VK_END);
							CuSdKduSuCd(VK_RIGHT);
							Kdu('W');
							nStep = 2;
							goto RECURSIVE;
						} else if (!strnicmp(szApplicationName, "nlnotes.exe", sizeof(szApplicationName))) {
							CuKduCd(VK_END);
							CuSdKduSuCd(VK_DOWN);
							CuSdKduSuCd(VK_HOME);
							Kdu('W');
							nStep = 2;
							goto RECURSIVE;
						} else {
							// default
							CuKduCd(VK_RIGHT);
							if (!SetClipboardText(&szOriginalClipboardText)) {
								//AfxMessageBox("Fait to save original clipboard data"); // aryaryann koryaryann
							}
							goto HOOK;
						}
					}

					if (szClipboardText.GetAt(0) != VK_RETURN) {
						if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName))) {
							CuSdKduKduSuCd(VK_END, VK_LEFT);
							CuSdKduSuCd(VK_DELETE);
						} else {
							CuSdKduKduSuCd(VK_END, VK_DELETE);

//							if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName)) ||
//								!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
							if (!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
								CuKduCd(VK_RETURN);
								CuKduCd(VK_LEFT);
							}
						}

//						CuSdKduSuCd(VK_END);
//						if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName)) ||
//							!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
//							CuSdKduSuCd(VK_LEFT);
//						}
//						Kdu('W');
					} else {
						CuSdKduSuCd(VK_RIGHT);
						Kdu('W');
					}

					nStep = 2;
					goto RECURSIVE;
				case 2:
					{
						nStep = 0;
						szClipboardText.Empty();
						GetClipboardText(&szClipboardText);

//						CString sz;
//						sz.Format("%x, %x, %x, %x, %x, %x, %s", szClipboardText.GetAt(0), szClipboardText.GetAt(1), szClipboardText.GetAt(2), szClipboardText.GetAt(3), szClipboardText.GetAt(4), szClipboardText.GetAt(5), szClipboardText);
//						AfxMessageBox(sz);

						int nEnter = szClipboardText.Find(VK_RETURN, 1);
						if ( nEnter != -1 ) {
							CuKduCd(VK_RETURN);
							CuKduCd(VK_LEFT);
							szClipboardText = szClipboardText.Left(nEnter);
						}

						nStep = 3;
						goto RECURSIVE;
					}
				case 3:
					nStep = 0;
					if (!szClipboardText.IsEmpty())
						if (!SetClipboardText(&szClipboardText)) {
							//AfxMessageBox("Fait to save original clipboard data"); // aryaryann koryaryann
						}
					goto HOOK;
					break;
				}
			}

		case 'L':
			// C-l: Recenter
			if (!strnicmp(szApplicationName, "b2.exe", sizeof(szApplicationName))) {
				static int nStep = 0;
				RECT ClientRect;
				GetClientRect(GetFocus(), &ClientRect);
				static int gap = INT_MAX;

				static POINT CaretPos;
				GetCaretPos(&CaretPos);

				switch(nStep) {
				case 0:
					nStep = 0;	// omaginai
					if (CaretPos.y < ClientRect.bottom / 2)
						SendMessage(GetFocus(), WM_VSCROLL, SB_LINEUP, NULL);
					else if (ClientRect.bottom / 2 < CaretPos.y)
						SendMessage(GetFocus(), WM_VSCROLL, SB_LINEDOWN, NULL);
					else {
						gap = INT_MAX;
						goto HOOK;
						break;
					}

					CuKduCd(VK_DOWN);
					nStep = 1;
					goto RECURSIVE;

				case 1:
					nStep = 0;
					// When a client screen can display 2n lines, the center line is (n + 1)th line.
					int newgap = CaretPos.y - ClientRect.bottom / 2;
					if (fabs(gap) <= fabs(newgap)) {
						if ((fabs(gap) == fabs(newgap)) && (gap != newgap) && newgap < 0)
							SendMessage(GetFocus(), WM_VSCROLL, SB_LINEUP, NULL);
						gap = INT_MAX;
						goto HOOK;
						break;
					}

					gap = newgap;
					goto RECURSIVE;
				}
			}
			else
			{
				RECT ClientRect;
				GetClientRect(GetFocus(), &ClientRect);
				int gap = INT_MAX;

				for (;;) {
					POINT CaretPos;
					GetCaretPos(&CaretPos);

					if (CaretPos.y < ClientRect.bottom / 2)
						SendMessage(GetFocus(), WM_VSCROLL, SB_LINEUP, NULL);
					else if (ClientRect.bottom / 2 < CaretPos.y)
						SendMessage(GetFocus(), WM_VSCROLL, SB_LINEDOWN, NULL);
					else
						break;

					// When a client screen can display 2n lines, the center line is (n + 1)th line.
					int newgap = CaretPos.y - ClientRect.bottom / 2;
					if (fabs(gap) <= fabs(newgap)) {
						if ((fabs(gap) == fabs(newgap)) && (gap != newgap) && newgap < 0)
							SendMessage(GetFocus(), WM_VSCROLL, SB_LINEUP, NULL);
						break;
					}
					gap = newgap;
				}
				goto HOOK;
			}

		case 'M':
			// C-m: Enter
			CuKduCd(VK_RETURN, m_nRepeat);
			goto HOOK;

		case 'N':
			// C-n: Down
			CuKduCd(VK_DOWN, m_nRepeat);
			goto HOOK;

		case 'O':
			// Ctrl-o: Open...
//			if (bOriginalC_o) {
			if (m_bOriginal[CONTROL_FOO]['O']) {
//				bOriginalC_o = FALSE;
				m_bOriginal[CONTROL_FOO]['O'] = FALSE;
				goto DO_NOTHING;
			}

			// C-o: Toggle IME
			else {
				ToggleIME(szApplicationName, sizeof(szApplicationName));
				goto HOOK;
			}

		case 'P':
			// C-x C-p: Ctrl-End, Ctrl-Shift-Home
			if (m_bC_x) {
				Kdu(VK_END);
				DepressKey(VK_SHIFT);
				Kdu(VK_HOME);
				ReleaseKey(VK_SHIFT);
				goto HOOK;
			}

			// C-p: Up
			CuKduCd(VK_UP, m_nRepeat);
			goto HOOK;

		case 'R':
//			Search(BACKWARD, szApplicationName, sizeof(szApplicationName), &bOriginalC_f, &bOriginalM_b, &bOriginalM_f);
			Search(BACKWARD, szApplicationName, sizeof(szApplicationName));
			goto HOOK;

		case 'S':
			// C-x C-s: Alt-F, Alt-S
			if (m_bC_x) {
				if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName))) {
					// M$ Word
					m_bC_x = FALSE;
					goto DO_NOTHING;
				} else {
					// default
//					bOriginalM_f = TRUE;
					m_bOriginal[META_FOO]['F'] = TRUE;
					CuAdKduKduAuCd('F', 'S');
					goto HOOK;
				}
			}

			// C-s:
//			Search(FORWARD, szApplicationName, sizeof(szApplicationName), &bOriginalC_f, &bOriginalM_b, &bOriginalM_f);
			Search(FORWARD, szApplicationName, sizeof(szApplicationName));
			goto HOOK;

		case 'T':
			// C-t: Shift-Left, Shift-Delete, Right Shift-Insert, if the cursor is not at EOL (is End Of Line)
			//		Left, Shift-Right, Shift-Delete, Left, Shift-Insert, Right, if the cursor is at EOL
			{
				static CString szOriginalClipboardText;
				// Do not try to do these command at once.
				// Clipboard has old data till you go out this function.
				static int nStep = 0;
				switch (nStep) {
				case 0:
					szOriginalClipboardText.Empty();
					if (!GetClipboardText(&szOriginalClipboardText))
						szOriginalClipboardText.Empty();
//					AfxMessageBox(szOriginalClipboardText);

					// simple version
					if (!strnicmp(szApplicationName, "123w.exe", sizeof(szApplicationName))) {
						// C-t: Left, Shift-Right, Shift-Delete, Left, Shift-Insert, Right
						ReleaseKey(VK_CONTROL);
						Kdu(VK_LEFT);
						DepressKey(VK_SHIFT);
						Kdu(VK_RIGHT);
						Kdu(VK_DELETE);
						ReleaseKey(VK_SHIFT);
						Kdu(VK_LEFT);
						DepressKey(VK_SHIFT);
						Kdu(VK_INSERT);
						ReleaseKey(VK_SHIFT);
						Kdu(VK_RIGHT);
						DepressKey(VK_CONTROL);
						nStep = 3;
						goto RECURSIVE;
						break;	// needless
					}
				
					if (!CopyBackCharacter())
						goto DO_NOTHING;

					nStep = 1;
					goto RECURSIVE;
					break;	// needless
				case 1:
					{
						nStep = 0;
						CString szClipboardText;
						GetClipboardText(&szClipboardText);

//						CString sz;
//						sz.Format("%x, %d, %s", szClipboardText.GetAt(0), szClipboardText.GetLength(), szClipboardText);
//						AfxMessageBox(sz);

						// Top Of File
						if (szClipboardText.IsEmpty() ||		// for normal application
							szClipboardText.GetLength() >= 3) {	// for VC++
							CuKduCd(VK_LEFT);
							nStep = 3;
							goto RECURSIVE;
						}

						if (!CopyNextCharacter()) {
							nStep = 3;
							goto RECURSIVE;
						}

						nStep = 2;
						goto RECURSIVE;
						break;	// needless
					}
				case 2:
					{
						nStep = 0;
						CString szClipboardText;
						GetClipboardText(&szClipboardText);

//						CString sz;
//						sz.Format("%x, %d, %s", szClipboardText.GetAt(0), szClipboardText.GetLength(), szClipboardText);
//						AfxMessageBox(sz);

						if (!szClipboardText.IsEmpty() &&
							szClipboardText.GetAt(0) != VK_RETURN) {
							ReleaseKey(VK_CONTROL);
							DepressKey(VK_SHIFT);
							Kdu(VK_LEFT);
							Kdu(VK_DELETE);
							ReleaseKey(VK_SHIFT);
							Kdu(VK_RIGHT);
							DepressKey(VK_SHIFT);
							Kdu(VK_INSERT);
							ReleaseKey(VK_SHIFT);
							DepressKey(VK_CONTROL);
						} else {
							if (szClipboardText.IsEmpty())	// EOF
								if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName)) ||
									!strnicmp(szApplicationName, "frontpg.exe", sizeof(szApplicationName)) ||
									!strnicmp(szApplicationName, "nlnotes.exe", sizeof(szApplicationName)) ||
									!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
									// These applications say "EOL is EOF".
									CuKduCd(VK_END);
								} else {
									// default
									CuKduCd(VK_RIGHT);
								}

							ReleaseKey(VK_CONTROL);
							Kdu(VK_LEFT);
							DepressKey(VK_SHIFT);
							Kdu(VK_RIGHT);
							Kdu(VK_DELETE);
							ReleaseKey(VK_SHIFT);
							Kdu(VK_LEFT);
							DepressKey(VK_SHIFT);
							Kdu(VK_INSERT);
							ReleaseKey(VK_SHIFT);
							Kdu(VK_RIGHT);
							DepressKey(VK_CONTROL);
						}

						nStep = 3;
						goto RECURSIVE;
						break;	// needless
					}
				case 3:
					nStep = 0;
					if (!SetClipboardText(&szOriginalClipboardText)) {
						//AfxMessageBox("Fait to save original clipboard data"); // aryaryann koryaryann
					}
					goto HOOK;
					break;	// needless
				}
			}

		case 'V':
			// Ctrl-V: Paste
//			if (bOriginalC_v) {
			if (m_bOriginal[CONTROL_FOO]['V']) {
//				bOriginalC_v = FALSE;
				m_bOriginal[CONTROL_FOO]['V'] = FALSE;
				goto DO_NOTHING;
			}

			// C-v: Page Down
			else {
				CuKduCd(VK_NEXT, m_nRepeat);
				goto HOOK;
			}

		case 'W':
			// C-x C-w: Alt-F, Alt-A
			if (m_bC_x) {
//				bOriginalM_f = TRUE;
				m_bOriginal[META_FOO]['F'] = TRUE;
				CuAdKduKduAuCd('F', 'A');
				goto HOOK;
			}

			// C-w: Ctrl-X
			if (IsDown(VK_SHIFT))
				ReleaseKey(VK_SHIFT);
//			bOriginalC_x = TRUE;
			m_bOriginal[CONTROL_FOO]['X'] = TRUE;
			Kdu('X');
			goto HOOK;

		case 'X':
			// Ctrl-X: Cut
//			if (bOriginalC_x) {
			if (m_bOriginal[CONTROL_FOO]['X']) {
//				bOriginalC_x = FALSE;
				m_bOriginal[CONTROL_FOO]['X'] = FALSE;
				goto DO_NOTHING;
			}

			// C-x: only set flag
			else {
				m_bC_x = TRUE;
				goto HOOKX;
			}

		case 'Y':
			// C-y: Ctrl-V
			if (IsDown(VK_SHIFT))
				ReleaseKey(VK_SHIFT);
//			bOriginalC_v = TRUE;
			m_bOriginal[CONTROL_FOO]['V'] = TRUE;
			Kdu('V');
			goto HOOK;

		case 'Z':
			// Ctrl-Z: Undo
//			if (bOriginalC_z) {
			if (m_bOriginal[CONTROL_FOO]['X']) {
//				bOriginalC_z = FALSE;
				m_bOriginal[CONTROL_FOO]['X'] = FALSE;
				goto DO_NOTHING;
			}

			// C-z: Alt-Space, Alt-N
			else {
				CuAdKduKduAuCd(VK_SPACE, 'N');
				goto HOOK;
			}

		case VK_SPACE:
			// C-space: Shift
			if (IsDown(VK_SHIFT))
				ReleaseKey(VK_SHIFT);
			else
				DepressKey(VK_SHIFT);
			goto HOOK;

		case VK_OEM_4:	// 0xDB	Used for miscellaneous characters; it can vary by keyboard. 
						//		Windows 2000/XP: For the US standard keyboard, the '[{' key
			m_bM_ = TRUE;
			goto HOOKX;

		case 0xBF:
			// C-/: Ctrl-Z
			if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName))) {
				PostMessage(GetFocus(), WM_KEYDOWN, 'Z', 0);
				goto HOOK;
			}
//			bOriginalC_z = TRUE;
			m_bOriginal[CONTROL_FOO]['Z'] = TRUE;
			Kdu('Z');
			goto HOOK;

		case 0xDC:	// C-\: Toggle IME
		case 0xE2:	// C-BACKSLASH of 106/109 keyboard: Toggle IME
			ToggleIME(szApplicationName, sizeof(szApplicationName));
			goto HOOK;

		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			// C-0...9
			m_nRepeat = m_nRepeat * 10 + (wParam - '0');
			goto HOOK0_9;

		default:
			ASSERT(0);
			break;
		}	// switch (wParam)
	}	// if (IsDown(VK_CONTROL))

	// M-?
	if (IsMeta(nApp)) {
//		if (M_Foo(wParam, m_nRepeat, &bOriginalM_b, &bOriginalM_f))
		if (M_Foo(wParam, m_nRepeat))
			goto HOOK;
		goto DO_NOTHING;
	}

	switch (wParam) {
		case 'U':
			// C-x u: Ctrl-Z
			if (m_bC_x) {
				DepressKey(VK_CONTROL);
				PostMessage(GetFocus(), WM_KEYDOWN, 'Z', 0);
				ReleaseKey(VK_CONTROL);
				goto HOOK;
			}
			goto DO_NOTHING;

		case VK_ESCAPE:
			m_bM_ = TRUE;
			goto DO_NOTHING;

		default:
			ASSERT(0);
			break;
	}
*/

DO_NOTHING:
	return ::CallNextHookEx(m_hHookKeyboard, code, wParam, lParam);

RECURSIVE:
//	LRESULT result;
//	result = ::CallNextHookEx(m_hHookKeyboard, code, wParam, lParam);
	ASSERT(0 <= wParam && wParam <= UCHAR_MAX);
//	Kdu((BYTE)wParam);
	wRecursiveCommand = wParam;
	CdKduCu((BYTE)wParam);	// tmp
//	return result;
	return TRUE;

HOOK:
	m_nRepeat	= 0;
HOOK0_9:
	if (lParam & TRANSITION) {
		m_bC_x	= FALSE;
		m_bM_	= FALSE;
	}
HOOKX:
	if (lParam & TRANSITION) {
		if (m_bControl) {
			BYTE ks[256];

			DepressKey(VK_CONTROL);

			GetKeyboardState( ks );
			ks[ VK_CONTROL ] = 1;
			SetKeyboardState( ks );
		}

		if (m_bAlt) {
			Kdu(VK_MENU);	// for not to selecgt menu
			DepressKey(VK_MENU);
		}

		if (m_bShift)
			DepressKey(VK_SHIFT);
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// CXkeymacsData Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXkeymacsData::CXkeymacsData()
{
	ClearAll();
}

CXkeymacsData::~CXkeymacsData()
{

}

// set application name
void CXkeymacsData::SetApplicationName(LPCTSTR lpszApplicationName)
{
	m_strApplicationName.Format(lpszApplicationName);
}

// return application name
CString CXkeymacsData::GetApplicationName()
{
	return m_strApplicationName;
}

// set hook or not
void CXkeymacsData::SetEnable(int nCommandType, int nKey, int nEnable)
{
	ASSERT(0 <= nCommandType	|| nCommandType	< MAX_COMMAND_TYPE);
	ASSERT(0 <= nKey			|| nKey			< MAX_KEY);

	m_nEnable[nCommandType][nKey] = nEnable;
}

// return hook or not
int CXkeymacsData::GetEnable(int nCommandType, int nKey)
{
	ASSERT(0 <= nCommandType	|| nCommandType	< MAX_COMMAND_TYPE);
	ASSERT(0 <= nKey			|| nKey			< MAX_KEY);

	return m_nEnable[nCommandType][nKey];
}

// clear all data
void CXkeymacsData::ClearAll()
{
	ZeroMemory(m_nEnable, sizeof(m_nEnable));
	m_strApplicationName.Empty();
}

// set application name
void CXkeymacsDll::SetApplicationName(int nApp, CString szApplicationName)
{
	ZeroMemory(m_szSpecialApp[nApp], sizeof(m_szSpecialApp[nApp]));
	strncpy(m_szSpecialApp[nApp], szApplicationName, sizeof(m_szSpecialApp[nApp]));
}

// return root window of focused window
HWND CXkeymacsDll::GetFocusRoot()
{
	HWND hWnd, hRootWnd;
	for (hRootWnd = hWnd = GetFocus(); hWnd; hWnd = GetParent(hWnd))
		hRootWnd = hWnd;
	return hRootWnd;
}

// set m_nEnable[nApp][nCommandType][nKey] nEnable
void CXkeymacsDll::SetEnable(int nApp, int nCommandType, int nKey, int nEnable)
{
	m_nEnable[nApp][nCommandType][nKey] = nEnable;
}

// Clear data of nApp
void CXkeymacsDll::Clear(int nApp)
{
	if (0 <= nApp && nApp < MAX_APP) {
		ZeroMemory(m_szSpecialApp[nApp], sizeof(m_szSpecialApp[nApp]));
		ZeroMemory(m_nEnable[nApp], sizeof(m_nEnable[nApp]));
	} else
		ASSERT(0);
}

// Set m_hPrevWnd 0 for that KeyboardProc() updates data 
void CXkeymacsDll::UpdateData()
{
	m_hPrevWnd = 0;
}

void CXkeymacsData::SetApplicationTitle(LPCTSTR lpszApplicationTitle)
{
	m_strApplicationTitle.Format(lpszApplicationTitle);
}

CString CXkeymacsData::GetApplicationTitle()
{
	return m_strApplicationTitle;
}

BOOL CXkeymacsDll::GetClipboardText(CString *szClipboardText)
{
	if (!OpenClipboard(NULL)) {
//		AfxMessageBox("Cannot open the Clipboard");
		return FALSE;
	}

	HANDLE hClipboardText;
//	if ((hClipboardText = ::GetClipboardData(CF_TEXT)) == NULL) {
	if ((hClipboardText = ::GetClipboardData(CF_OEMTEXT)) == NULL) {
		DWORD dw = GetLastError();
		CString szMessage;
		szMessage.Format("Unable to get Clipboard data: %d", dw);
//		AfxMessageBox(szMessage);
		CloseClipboard();
		return FALSE;
	}

	szClipboardText->Format("%s", hClipboardText);
	EmptyClipboard();
	CloseClipboard();
	return TRUE;
}

BOOL CXkeymacsDll::SetClipboardText(CString *szClipboardText)
{
	if (!OpenClipboard(NULL)) {
//		AfxMessageBox("Cannot open the Clipboard in SetClipboardText");
		return FALSE;
	}

	int nLength = szClipboardText->GetLength() + 1;
	HGLOBAL hClipboardText = GlobalAlloc(GHND, nLength);
	if (hClipboardText == NULL) {
//		AfxMessageBox("Failed: GlobalAlloc in SetClipboardText");
		return FALSE;
	}

	LPSTR lpStr = (LPSTR)GlobalLock(hClipboardText);
	lstrcpyn(lpStr, *szClipboardText, nLength);
	GlobalUnlock(hClipboardText);
	EmptyClipboard();

	if ((hClipboardText = ::SetClipboardData(CF_OEMTEXT, hClipboardText)) == NULL) {
//		DWORD dw = GetLastError();
//		CString szMessage;
//		szMessage.Format("Unable to set Clipboard data: %d", dw);
//		AfxMessageBox(szMessage);
		CloseClipboard();
		return FALSE;
	}

	CloseClipboard();
	return TRUE;

}

/*
//BOOL CXkeymacsDll::M_Foo(WPARAM wParam, int m_nRepeat, BOOL *bOriginalM_b, BOOL *bOriginalM_f)
BOOL CXkeymacsDll::M_Foo(WPARAM wParam, int m_nRepeat)
{
	BOOL bIsAltDown = IsDown(VK_MENU);

	switch (wParam) {
	case 'B':
		if (bIsAltDown)
//			if (*bOriginalM_b) {
			if (m_bOriginal[META_FOO]['B']) {
//				*bOriginalM_b = FALSE;
				m_bOriginal[META_FOO]['B'] = FALSE;
				return FALSE;
			}

		// M-b: backward-word
		if (bIsAltDown)
			ReleaseKey(VK_MENU);

		CdKduCu(VK_LEFT, m_nRepeat);

		if (bIsAltDown)
			DepressKey(VK_MENU);

		return TRUE;

	case 'F':
		if (bIsAltDown)
//			if (*bOriginalM_f) {
			if (m_bOriginal[META_FOO]['F']) {
//				*bOriginalM_f = FALSE;
				m_bOriginal[META_FOO]['F'] = FALSE;
				return FALSE;
			}

		// M-f: forward-word
		if (bIsAltDown)
			ReleaseKey(VK_MENU);

		CdKduCu(VK_RIGHT, m_nRepeat);

		if (bIsAltDown)
			DepressKey(VK_MENU);

		return TRUE;

	case 'V':
		// M-v: Page Up
		if (bIsAltDown)
			ReleaseKey(VK_MENU);

		Kdu(VK_PRIOR, m_nRepeat);

		if (bIsAltDown)
			DepressKey(VK_MENU);

		return TRUE;

	case 'W':
		// M-w: Ctrl-C
		if (bIsAltDown)
			ReleaseKey(VK_MENU);

		if (IsDown(VK_SHIFT))
			ReleaseKey(VK_SHIFT);
		CdKduCu('C');

		if (bIsAltDown)
			DepressKey(VK_MENU);

		return TRUE;

	case VK_OEM_COMMA:	// 0xBC Windows 2000/XP: For any country/region, the ',' key
		// M-<:
		if (IsDown(VK_SHIFT)) {

			if (bIsAltDown)
				ReleaseKey(VK_MENU);

			ReleaseKey(VK_SHIFT);
			CdKduCu(VK_HOME);
			DepressKey(VK_SHIFT);

			if (bIsAltDown)
				DepressKey(VK_MENU);

			return TRUE;
		}
		break;

	case VK_OEM_PERIOD:	// 0xBE Windows 2000/XP: For any country/region, the '.' key
		// M->:
		if (IsDown(VK_SHIFT)) {

			if (bIsAltDown)
				ReleaseKey(VK_MENU);

			ReleaseKey(VK_SHIFT);
			CdKduCu(VK_END);
			DepressKey(VK_SHIFT);

			if (bIsAltDown)
				DepressKey(VK_MENU);

			return TRUE;
		}
		break;

	case '1':
		// M-!: cmd.exe/command.com
		if (IsDown(VK_SHIFT)) {
			STARTUPINFO si;
			memset(&si, 0, sizeof(STARTUPINFO));
			PROCESS_INFORMATION pi;
			memset(&pi, 0, sizeof(PROCESS_INFORMATION));

			char *terminal = getenv("COMSPEC");
			if (terminal)
				CreateProcess(NULL, terminal, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
			return TRUE;
		}
		break;

	default:
		if (bIsAltDown)
			ASSERT(0);
		break;
	}
	return FALSE;
}
*/

BOOL CXkeymacsDll::IsMeta(int nApp)
{
	switch (m_OsVersionInfo.dwPlatformId) {
	case VER_PLATFORM_WIN32_NT:
		return (IsDown(VK_RMENU) && m_nEnable[nApp][NONE_FOO][VK_RMENU]) ||
			   (IsDown(VK_LMENU) && m_nEnable[nApp][NONE_FOO][VK_LMENU]) ||
			   m_bM_;
		break;
	case VER_PLATFORM_WIN32_WINDOWS:
		return (IsDown(VK_MENU) && m_nEnable[nApp][NONE_FOO][VK_MENU]) ||
			   m_bM_;
		break;
	default:
		return FALSE;
		break;
	}
}

ReturnCode CXkeymacsDll::DoCommand(int nCommandID, LPARAM lParam, char *szApplicationName)
{
	ReturnCode (*command)(LPARAM, char *);

	switch(nCommandID) {
	case IDS_BEGINNING_OF_LINE:
		command = BeginningOfLine;
		break;
	case IDS_BACKWARD_CHAR:
		command = BackwardChar;
		break;
	case IDS_DELETE_CHAR:
		command = DeleteChar;
		break;
	case IDS_END_OF_LINE:
		command = EndOfLine;
		break;
	case IDS_FORWARD_CHAR:
		command = ForwardChar;
		break;
	case IDS_KEYBOARD_QUIT:
		command = KeyboardQuit;
		break;
	case IDS_BACKWARD_DELETE_CHAR:
		command = BackwardDeleteChar;
		break;
	case IDS_KILL_LINE:
		command = KillLine;
		break;
	case IDS_RECENTER:
		command = Recenter;
		break;
	case IDS_NEWLINE:
		command = Newline;
		break;
	case IDS_NEXT_LINE:
		command = NextLine;
		break;
	case IDS_TOGGLE_WIN32IME_MODE:
		command = ToggleWin32imeMode;
		break;
	case IDS_PREVIOUS_LINE:
		command = PreviousLine;
		break;
	case IDS_ISEARCH_BACKWARD:
		command = IsearchBackward;
		break;
	case IDS_ISEARCH_FORWARD:
		command = IsearchForward;
		break;
	case IDS_TRANSPOSE_CHARS:
		command = TransposeChars;
		break;
	case IDS_SCROLL_UP:
		command = ScrollUp;
		break;
	case IDS_KILL_REGION:
		command = KillRegion;
		break;
	case IDS_CONTROL_X_PREFIX:
		command = ControlXPrefix;
		break;
	case IDS_YANK:
		command = Yank;
		break;
	case IDS_ICONIFY_OR_DEICONIFY_FRAME:
		command = IconifyOrDeiconifyFrame;
		break;
	case IDS_TAB:
		command = Tab;
		break;
	case IDS_SET_MARK_COMMAND:
		command = SetMarkCommand;
		break;
	case IDS_META_PREFIX_AND_ORIGINAL:
		command = MetaPrefixAndOriginal;
		break;
	case IDS_META_PREFIX:
		command = MetaPrefix;
		break;
	case IDS_META:
		command = Meta;
		break;
	case IDS_UNDO:
		command = Undo;
		break;
	case IDS_DIGIT_ARGUMENT9:
		command = DigitArgument9;
		break;
	case IDS_DIGIT_ARGUMENT8:
		command = DigitArgument8;
		break;
	case IDS_DIGIT_ARGUMENT7:
		command = DigitArgument7;
		break;
	case IDS_DIGIT_ARGUMENT6:
		command = DigitArgument6;
		break;
	case IDS_DIGIT_ARGUMENT5:
		command = DigitArgument5;
		break;
	case IDS_DIGIT_ARGUMENT4:
		command = DigitArgument4;
		break;
	case IDS_DIGIT_ARGUMENT3:
		command = DigitArgument3;
		break;
	case IDS_DIGIT_ARGUMENT2:
		command = DigitArgument2;
		break;
	case IDS_DIGIT_ARGUMENT1:
		command = DigitArgument1;
		break;
	case IDS_DIGIT_ARGUMENT0:
		command = DigitArgument0;
		break;
	case IDS_SAVE_BUFFERS_KILL_EMACS:
		command = SaveBuffersKillEmacs;
		break;
	case IDS_FIND_FILE:
		command = FindFile;
		break;
	case IDS_MARK_PAGE:
		command = MarkPage;
		break;
	case IDS_SAVE_BUFFER:
		command = SaveBuffer;
		break;
	case IDS_WRITE_FILE:
		command = WriteFile;
		break;
	case IDS_BACKWARD_WORD:
		command = BackwardWord;
		break;
	case IDS_FORWARD_WORD:
		command = ForwardWord;
		break;
	case IDS_SCROLL_DOWN:
		command = ScrollDown;
		break;
	case IDS_KILL_RING_SAVE:
		command = KillRingSave;
		break;
	case IDS_BEGINNING_OF_BUFFER:
		command = BeginningOfBuffer;
		break;
	case IDS_END_OF_BUFFER:
		command = EndOfBuffer;
		break;
	case IDS_SHELL_COMMAND:
		command = ShellCommand;
		break;
	default:
		command = NULL;
		break;
	}

	if (command)
		return command(lParam, szApplicationName);
	else
		return RC_DO_NOTHING;
}

// C-a
inline ReturnCode CXkeymacsDll::BeginningOfLine(LPARAM lParam, char *szApplicationName)
{
	if (m_bShift)
		DepressKey(VK_SHIFT);

	Kdoru(VK_HOME, lParam);

	return RC_HOOK;
}

// C-b
inline ReturnCode CXkeymacsDll::BackwardChar(LPARAM lParam, char *szApplicationName)
{
	if (m_bShift)
		DepressKey(VK_SHIFT);

	Kdoru(VK_LEFT, lParam, m_nRepeat);

	return RC_HOOK;
}

// C-d
inline ReturnCode CXkeymacsDll::DeleteChar(LPARAM lParam, char *szApplicationName)
{
//	if (IsDown(VK_SHIFT))
//		ReleaseKey(VK_SHIFT);
	m_bShift = FALSE;
	Kdoru(VK_DELETE, lParam, m_nRepeat);
	return RC_HOOK;
}

// C-e
inline ReturnCode CXkeymacsDll::EndOfLine(LPARAM lParam, char *szApplicationName)
{
	if (m_bShift)
		DepressKey(VK_SHIFT);

	Kdoru(VK_END, lParam);

	return RC_HOOK;
}

// C-f
inline ReturnCode CXkeymacsDll::ForwardChar(LPARAM lParam, char *szApplicationName)
{
	if (m_bShift)
		DepressKey(VK_SHIFT);

	Kdoru(VK_RIGHT, lParam, m_nRepeat);

	return RC_HOOK;
}

// C-g
inline ReturnCode CXkeymacsDll::KeyboardQuit(LPARAM lParam, char *szApplicationName)
{
//	if (IsDown(VK_SHIFT))
//		ReleaseKey(VK_SHIFT);
	m_bShift = FALSE;
	return RC_HOOK;
}

// C-h
inline ReturnCode CXkeymacsDll::BackwardDeleteChar(LPARAM lParam, char *szApplicationName)
{
//	if (IsDown(VK_SHIFT))
//		ReleaseKey(VK_SHIFT);
	m_bShift = FALSE;
	Kdoru(VK_BACK, lParam, m_nRepeat);
	return RC_HOOK;
}

// C-i
inline ReturnCode CXkeymacsDll::Tab(LPARAM lParam, char *szApplicationName)
{
//	if (IsDown(VK_SHIFT))
//		ReleaseKey(VK_SHIFT);
	m_bShift = FALSE;
	Kdoru(VK_TAB, lParam);
	return RC_HOOK;
}

// C-k
inline ReturnCode CXkeymacsDll::KillLine(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOK;

	// C-k: Shift-End, Shift-Delete, if the cursor is not at EOL (is End Of Line)
	//		Shift-Right, Cut, if the cursor is at EOL
	if (!strnicmp(szApplicationName, "123w.exe", sizeof(szApplicationName))) {
		// C-k: Shift-End, Control-x
		SdKduSu(VK_END);
		CdKduCu('X');
		return RC_HOOK;
	}

	{
		static CString szOriginalClipboardText;
		// Do not try to do these command at once.
		// Clipboard has old data till you go out this function.
		static int nStep = 0;
		static CString szClipboardText;

		switch (nStep) {
		case 0:
			szOriginalClipboardText.Empty();
			if (!GetClipboardText(&szOriginalClipboardText))
				szOriginalClipboardText.Empty();

			if (!CopyNextCharacter())
				return RC_DO_NOTHING;

			nStep = 1;
			return RC_RECURSIVE;
		case 1:
			nStep = 0;

			szClipboardText.Empty();
			GetClipboardText(&szClipboardText);

//			{
//				CString sz;
//				sz.Format("%x, %s", szClipboardText.GetAt(0), szClipboardText);
//				AfxMessageBox(sz);
//			}

			if (szClipboardText.IsEmpty()) {	// EOF
				if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName)) ||
					!strnicmp(szApplicationName, "frontpg.exe", sizeof(szApplicationName)) ||
					!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
					Kdu(VK_END);
					SdKduSu(VK_RIGHT);
					CdKduCu('X');
					nStep = 2;
					return RC_RECURSIVE;
				} else if (!strnicmp(szApplicationName, "nlnotes.exe", sizeof(szApplicationName))) {
					Kdu(VK_END);
					SdKduSu(VK_DOWN);
					SdKduSu(VK_HOME);
					CdKduCu('X');
					nStep = 2;
					return RC_RECURSIVE;
				} else {
					// default
					Kdu(VK_RIGHT);
					if (!SetClipboardText(&szOriginalClipboardText)) {
						//AfxMessageBox("Fait to save original clipboard data"); // aryaryann koryaryann
					}
					return RC_HOOK;
				}
			}

			if (szClipboardText.GetAt(0) != VK_RETURN) {
				SdKduKduSu(VK_END, VK_DELETE);

				if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName)) ||
					!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
					Kdu(VK_RETURN);
					Kdu(VK_LEFT);
				}

//				SdKduSu(VK_END);
//				if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName)) ||
//					!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
//					SdKduSu(VK_LEFT);
//				}
//				Kdu('W');
			} else {
				SdKduSu(VK_RIGHT);
				CdKduCu('X');
			}

			nStep = 2;
			return RC_RECURSIVE;
		case 2:
			{
				nStep = 0;
				szClipboardText.Empty();
				GetClipboardText(&szClipboardText);

//				CString sz;
//				sz.Format("%x, %x, %x, %x, %x, %x, %s", szClipboardText.GetAt(0), szClipboardText.GetAt(1), szClipboardText.GetAt(2), szClipboardText.GetAt(3), szClipboardText.GetAt(4), szClipboardText.GetAt(5), szClipboardText);
//				AfxMessageBox(sz);

				int nEnter = szClipboardText.Find(VK_RETURN, 1);
				if ( nEnter != -1 ) {
					Kdu(VK_RETURN);
					Kdu(VK_LEFT);
					szClipboardText = szClipboardText.Left(nEnter);
				}

				nStep = 3;
				return RC_RECURSIVE;
			}
		case 3:
			nStep = 0;
			if (!szClipboardText.IsEmpty())
				if (!SetClipboardText(&szClipboardText)) {
					//AfxMessageBox("Fait to save original clipboard data"); // aryaryann koryaryann
				}
			return RC_HOOK;
			break;
		default:
			ASSERT(0);
			return RC_HOOK;
		}
	}
}

// C-l
inline ReturnCode CXkeymacsDll::Recenter(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOK;

	// C-l: Recenter
	if (!strnicmp(szApplicationName, "b2.exe", sizeof(szApplicationName))) {
		static int nStep = 0;
		RECT ClientRect;
		GetClientRect(GetFocus(), &ClientRect);
		static int gap = INT_MAX;

		static POINT CaretPos;
		GetCaretPos(&CaretPos);

		switch(nStep) {
		case 0:
			nStep = 0;	// omaginai
			if (CaretPos.y < ClientRect.bottom / 2)
				SendMessage(GetFocus(), WM_VSCROLL, SB_LINEUP, NULL);
			else if (ClientRect.bottom / 2 < CaretPos.y)
				SendMessage(GetFocus(), WM_VSCROLL, SB_LINEDOWN, NULL);
			else {
				gap = INT_MAX;
				return RC_HOOK;
				break;
			}

			Kdu(VK_DOWN);
			nStep = 1;
			return RC_RECURSIVE;

		case 1:
			{
				nStep = 0;
				// When a client screen can display 2n lines, the center line is (n + 1)th line.
				int newgap = CaretPos.y - ClientRect.bottom / 2;
				if (fabs(gap) <= fabs(newgap)) {
					if ((fabs(gap) == fabs(newgap)) && (gap != newgap) && newgap < 0)
						SendMessage(GetFocus(), WM_VSCROLL, SB_LINEUP, NULL);
					gap = INT_MAX;
					return RC_HOOK;
					break;
				}

				gap = newgap;
				return RC_RECURSIVE;
			}

		default:
			ASSERT(0);
			return RC_HOOK;
		}
	}
	else
	{
		RECT ClientRect;
		GetClientRect(GetFocus(), &ClientRect);
		int gap = INT_MAX;

		for (;;) {
			POINT CaretPos;
			GetCaretPos(&CaretPos);

			if (CaretPos.y < ClientRect.bottom / 2)
				SendMessage(GetFocus(), WM_VSCROLL, SB_LINEUP, NULL);
			else if (ClientRect.bottom / 2 < CaretPos.y)
				SendMessage(GetFocus(), WM_VSCROLL, SB_LINEDOWN, NULL);
			else
				break;

			// When a client screen can display 2n lines, the center line is (n + 1)th line.
			int newgap = CaretPos.y - ClientRect.bottom / 2;
			if (fabs(gap) <= fabs(newgap)) {
				if ((fabs(gap) == fabs(newgap)) && (gap != newgap) && newgap < 0)
					SendMessage(GetFocus(), WM_VSCROLL, SB_LINEUP, NULL);
				break;
			}
			gap = newgap;
		}
		return RC_HOOK;
	}
}

// C-m
inline ReturnCode CXkeymacsDll::Newline(LPARAM lParam, char *szApplicationName)
{
//	if (IsDown(VK_SHIFT))
//		ReleaseKey(VK_SHIFT);
	m_bShift = FALSE;
	Kdoru(VK_RETURN, lParam, m_nRepeat);
	return RC_HOOK;
}

// C-n
inline ReturnCode CXkeymacsDll::NextLine(LPARAM lParam, char *szApplicationName)
{
	if (m_bShift)
		DepressKey(VK_SHIFT);

	Kdoru(VK_DOWN, lParam, m_nRepeat);

	return RC_HOOK;
}

// C-o
// C-\ 0xDC
// C-BACKSLASH of 106/109 keyboard 0xE2
// C-x C-j
inline ReturnCode CXkeymacsDll::ToggleWin32imeMode(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOK;

	ToggleIME(szApplicationName, sizeof(szApplicationName));
	return RC_HOOK;
}

// C-p
inline ReturnCode CXkeymacsDll::PreviousLine(LPARAM lParam, char *szApplicationName)
{
	if (m_bShift)
		DepressKey(VK_SHIFT);

	Kdoru(VK_UP, lParam, m_nRepeat);

	return RC_HOOK;
}

// C-r
inline ReturnCode CXkeymacsDll::IsearchBackward(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOK;

	m_bJack = TRUE;
	Search(BACKWARD, szApplicationName, sizeof(szApplicationName));
	return RC_HOOK;
}

// C-s
inline ReturnCode CXkeymacsDll::IsearchForward(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOK;

	m_bJack = TRUE;
	Search(FORWARD, szApplicationName, sizeof(szApplicationName));
	return RC_HOOK;
}

// C-t
inline ReturnCode CXkeymacsDll::TransposeChars(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOK;

	// C-t: Shift-Left, Shift-Delete, Right Shift-Insert, if the cursor is not at EOL (is End Of Line)
	//		Left, Shift-Right, Shift-Delete, Left, Shift-Insert, Right, if the cursor is at EOL
	{
		static CString szOriginalClipboardText;
		// Do not try to do these command at once.
		// Clipboard has old data till you go out this function.
		static int nStep = 0;
		switch (nStep) {
		case 0:
			szOriginalClipboardText.Empty();
			if (!GetClipboardText(&szOriginalClipboardText))
				szOriginalClipboardText.Empty();
//					AfxMessageBox(szOriginalClipboardText);

			// simple version
			if (!strnicmp(szApplicationName, "123w.exe", sizeof(szApplicationName))) {
				// C-t: Left, Shift-Right, Shift-Delete, Left, Shift-Insert, Right
				ReleaseKey(VK_CONTROL);
				Kdu(VK_LEFT);
				DepressKey(VK_SHIFT);
				Kdu(VK_RIGHT);
				Kdu(VK_DELETE);
				ReleaseKey(VK_SHIFT);
				Kdu(VK_LEFT);
				DepressKey(VK_SHIFT);
				Kdu(VK_INSERT);
				ReleaseKey(VK_SHIFT);
				Kdu(VK_RIGHT);
				DepressKey(VK_CONTROL);
				nStep = 3;
				return RC_RECURSIVE;
				break;	// needless
			}

			if (!CopyBackCharacter())
				return RC_DO_NOTHING;

			nStep = 1;
			return RC_RECURSIVE;
			break;	// needless
		case 1:
			{
				nStep = 0;
				CString szClipboardText;
				GetClipboardText(&szClipboardText);

//				CString sz;
//				sz.Format("%x, %d, %s", szClipboardText.GetAt(0), szClipboardText.GetLength(), szClipboardText);
//				AfxMessageBox(sz);

				// Top Of File
				if (szClipboardText.IsEmpty() ||		// for normal application
					szClipboardText.GetLength() >= 3) {	// for VC++
					Kdu(VK_LEFT);
					nStep = 3;
					return RC_RECURSIVE;
				}

				if (!CopyNextCharacter()) {
					nStep = 3;
					return RC_RECURSIVE;
				}

				nStep = 2;
				return RC_RECURSIVE;
				break;	// needless
			}
		case 2:
			{
				nStep = 0;
				CString szClipboardText;
				GetClipboardText(&szClipboardText);

//				CString sz;
//				sz.Format("%x, %d, %s", szClipboardText.GetAt(0), szClipboardText.GetLength(), szClipboardText);
//				AfxMessageBox(sz);

				if (!szClipboardText.IsEmpty() &&
					szClipboardText.GetAt(0) != VK_RETURN) {
					ReleaseKey(VK_CONTROL);
					DepressKey(VK_SHIFT);
					Kdu(VK_LEFT);
					Kdu(VK_DELETE);
					ReleaseKey(VK_SHIFT);
					Kdu(VK_RIGHT);
					DepressKey(VK_SHIFT);
					Kdu(VK_INSERT);
					ReleaseKey(VK_SHIFT);
					DepressKey(VK_CONTROL);
				} else {
					if (szClipboardText.IsEmpty())	// EOF
						if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName)) ||
							!strnicmp(szApplicationName, "frontpg.exe", sizeof(szApplicationName)) ||
							!strnicmp(szApplicationName, "nlnotes.exe", sizeof(szApplicationName)) ||
							!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
							// These applications say "EOL is EOF".
							Kdu(VK_END);
						} else {
							// default
							Kdu(VK_RIGHT);
						}

						ReleaseKey(VK_CONTROL);
						Kdu(VK_LEFT);
						DepressKey(VK_SHIFT);
						Kdu(VK_RIGHT);
						Kdu(VK_DELETE);
						ReleaseKey(VK_SHIFT);
						Kdu(VK_LEFT);
						DepressKey(VK_SHIFT);
						Kdu(VK_INSERT);
						ReleaseKey(VK_SHIFT);
						Kdu(VK_RIGHT);
						DepressKey(VK_CONTROL);
				}

				nStep = 3;
				return RC_RECURSIVE;
				break;	// needless
			}
		case 3:
			nStep = 0;
			if (!SetClipboardText(&szOriginalClipboardText)) {
				//AfxMessageBox("Fait to save original clipboard data"); // aryaryann koryaryann
			}
			return RC_HOOK;
			break;	// needless
		default:
			ASSERT(0);
			return RC_HOOK;
		}
	}
}

// C-v
inline ReturnCode CXkeymacsDll::ScrollUp(LPARAM lParam, char *szApplicationName)
{
	if (m_bShift)
		DepressKey(VK_SHIFT);

	Kdoru(VK_NEXT, lParam, m_nRepeat);

	return RC_HOOK;
}

// C-w
inline ReturnCode CXkeymacsDll::KillRegion(LPARAM lParam, char *szApplicationName)
{
//	if (lParam & TRANSITION)
//		return RC_HOOK;

//	if (IsDown(VK_SHIFT))
//		ReleaseKey(VK_SHIFT);
	m_bShift = FALSE;

//	CdKduCu('X');
	CdKdoruCu('X', lParam);
	return RC_HOOK;
}

// C-x
inline ReturnCode CXkeymacsDll::ControlXPrefix(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOKX;

	m_bC_x = TRUE;
	return RC_HOOKX;
}

// C-y
inline ReturnCode CXkeymacsDll::Yank(LPARAM lParam, char *szApplicationName)
{
//	if (lParam & TRANSITION)
//		return RC_HOOK;
//
////	if (IsDown(VK_SHIFT))
////		ReleaseKey(VK_SHIFT);
//	m_bShift = FALSE;
//
//	CdKduCu('V');
//	return RC_HOOK;
	
	m_bShift = FALSE;
	CdKdoruCu('V', lParam);
	return RC_HOOK;
}

// C-z
inline ReturnCode CXkeymacsDll::IconifyOrDeiconifyFrame(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOK;

//	AdKduKduAu(VK_SPACE, 'N');
	AdKduAu(VK_SPACE);
	Kdu('N');
	return RC_HOOK;
}

// C-Space
inline ReturnCode CXkeymacsDll::SetMarkCommand(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOK;

//	if (IsDown(VK_SHIFT))
//		ReleaseKey(VK_SHIFT);
//	else
//		DepressKey(VK_SHIFT);
	m_bShift = !m_bShift;

	return RC_HOOK;
}

// VK_ESCAPE
inline ReturnCode CXkeymacsDll::MetaPrefixAndOriginal(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_DO_NOTHING;

	m_bM_ = TRUE;
	return RC_DO_NOTHING;
}

// C-VK_OEM_4	// 0xDB	Used for miscellaneous characters; it can vary by keyboard. 
				//		Windows 2000/XP: For the US standard keyboard, the '[{' key
inline ReturnCode CXkeymacsDll::MetaPrefix(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOKX;

	m_bM_ = TRUE;
	return RC_HOOKX;
}

// Right Alt, Left Alt
inline ReturnCode CXkeymacsDll::Meta(LPARAM lParam, char *szApplicationName)
{
	return RC_DO_NOTHING;
}

// C-/ (i.e. C-0xBF)
// C-x u
inline ReturnCode CXkeymacsDll::Undo(LPARAM lParam, char *szApplicationName)
{
	if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName))) {
		if (lParam & TRANSITION)
			return RC_HOOK;
		PostMessage(GetFocus(), WM_KEYDOWN, 'Z', 0);
		return RC_HOOK;
	}

//	CdKduCu('Z');
	CdKdoruCu('Z', lParam);
	return RC_HOOK;
}

// C-0...9
inline ReturnCode CXkeymacsDll::DigitArgument0(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOK0_9;

	return DigitArgument(0);
}
inline ReturnCode CXkeymacsDll::DigitArgument1(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOK0_9;

	return DigitArgument(1);
}
inline ReturnCode CXkeymacsDll::DigitArgument2(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOK0_9;

	return DigitArgument(2);
}
inline ReturnCode CXkeymacsDll::DigitArgument3(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOK0_9;

	return DigitArgument(3);
}
inline ReturnCode CXkeymacsDll::DigitArgument4(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOK0_9;

	return DigitArgument(4);
}
inline ReturnCode CXkeymacsDll::DigitArgument5(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOK0_9;

	return DigitArgument(5);
}
inline ReturnCode CXkeymacsDll::DigitArgument6(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOK0_9;

	return DigitArgument(6);
}
inline ReturnCode CXkeymacsDll::DigitArgument7(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOK0_9;

	return DigitArgument(7);
}
inline ReturnCode CXkeymacsDll::DigitArgument8(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOK0_9;

	return DigitArgument(8);
}
inline ReturnCode CXkeymacsDll::DigitArgument9(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOK0_9;

	return DigitArgument(9);
}
inline ReturnCode CXkeymacsDll::DigitArgument(int n)
{
	m_nRepeat = m_nRepeat * 10 + n;
	return RC_HOOK0_9;
}

inline ReturnCode CXkeymacsDll::SaveBuffersKillEmacs(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOK;

	if (strnicmp(szApplicationName, "explorer.exe", sizeof(szApplicationName))) {
//		AdKduKduAu(VK_SPACE, 'C');
		AdKduAu(VK_SPACE);
		Kdu('C');
	} else
		AdKduAu(VK_F4);
	return RC_HOOK;
}

inline ReturnCode CXkeymacsDll::FindFile(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOK;

	m_bJack = TRUE;
//	AdKduKduAu('F', 'O');
	AdKduAu('F');
	Kdu('O');
	return RC_HOOK;
}

inline ReturnCode CXkeymacsDll::MarkPage(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION) {
		ReleaseKey(VK_CONTROL);
		return RC_HOOK;
	}

//	CdKduCu(VK_END);
//	DepressKey(VK_SHIFT);
//	CdKduCu(VK_HOME);
//	ReleaseKey(VK_SHIFT);

	// It is crazy, but work well (only if C-? ?!)
	DepressKey(VK_CONTROL);
	Kdu(VK_END);
	DepressKey(VK_SHIFT);
	Kdu(VK_HOME);
	ReleaseKey(VK_SHIFT);
	return RC_HOOK;
}

inline ReturnCode CXkeymacsDll::SaveBuffer(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)
		return RC_HOOK;

	m_bJack = TRUE;
	if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName))) {
		// M$ Word
		m_bC_x = FALSE;
		return RC_DO_NOTHING;	// doubt! CdKduCu('S'); return RC_HOOK; is right?!
	} else {
		// default
//		AdKduKduAu('F', 'S');
		AdKduAu('F');
		Kdu('S');
		return RC_HOOK;
	}
}

inline ReturnCode CXkeymacsDll::WriteFile(LPARAM lParam, char *szApplicationName)
{
//	AdKduKduAu('F', 'A');
	m_bJack = TRUE;
	AdKduAu('F');
	Kdu('A');
	return RC_HOOK;
}

inline ReturnCode CXkeymacsDll::BackwardWord(LPARAM lParam, char *szApplicationName)
{
//	if (lParam & TRANSITION)	// wrong! use CdKdoruCu
//		return RC_HOOK;

	if (m_bShift)
		DepressKey(VK_SHIFT);

//	CdKduCu(VK_LEFT, m_nRepeat);
	CdKdoruCu(VK_LEFT, lParam, m_nRepeat);

	return RC_HOOK;
}

inline ReturnCode CXkeymacsDll::ForwardWord(LPARAM lParam, char *szApplicationName)
{
//	if (lParam & TRANSITION)	// wrong! use CdKdoruCu
//		return RC_HOOK;

	if (m_bShift)
		DepressKey(VK_SHIFT);

//	CdKduCu(VK_RIGHT, m_nRepeat);
	CdKdoruCu(VK_RIGHT, lParam, m_nRepeat);

	return RC_HOOK;
}

inline ReturnCode CXkeymacsDll::ScrollDown(LPARAM lParam, char *szApplicationName)
{
	if (lParam & TRANSITION)	// wrong! use CdKdoruCu
		return RC_HOOK;

	if (m_bShift)
		DepressKey(VK_SHIFT);

	Kdu(VK_PRIOR, m_nRepeat);

	return RC_HOOK;
}

inline ReturnCode CXkeymacsDll::KillRingSave(LPARAM lParam, char *szApplicationName)
{
//	if (lParam & TRANSITION)	// wrong! use CdKdoruCu
//		return RC_HOOK;

//	if (IsDown(VK_SHIFT))
//		ReleaseKey(VK_SHIFT);
	m_bShift = FALSE;
//	CdKduCu('C');
	CdKdoruCu('C', lParam);
	return RC_HOOK;
}

inline ReturnCode CXkeymacsDll::BeginningOfBuffer(LPARAM lParam, char *szApplicationName)
{
////	if (IsDown(VK_SHIFT)) {
//		if (lParam & TRANSITION)	// wrong! use CdKdoruCu
//			return RC_HOOK;
//
////		ReleaseKey(VK_SHIFT);
//		CdKduCu(VK_HOME);
////		DepressKey(VK_SHIFT);
//		return RC_HOOK;
////	}
////	return RC_DO_NOTHING;

	CdKdoruCu(VK_HOME, lParam);
	return RC_HOOK;
}

inline ReturnCode CXkeymacsDll::EndOfBuffer(LPARAM lParam, char *szApplicationName)
{
////	if (IsDown(VK_SHIFT)) {
//		if (lParam & TRANSITION)	// wrong! use CdKdoruCu
//			return RC_HOOK;
//
////		ReleaseKey(VK_SHIFT);
//		CdKduCu(VK_END);
////		DepressKey(VK_SHIFT);
//		return RC_HOOK;
////	}
////	return RC_DO_NOTHING;

	CdKdoruCu(VK_END, lParam);
	return RC_HOOK;
}

inline ReturnCode CXkeymacsDll::ShellCommand(LPARAM lParam, char *szApplicationName)
{
//	if (IsDown(VK_SHIFT)) {
		if (lParam & TRANSITION)
			return RC_HOOK;

		STARTUPINFO si;
		memset(&si, 0, sizeof(STARTUPINFO));
		PROCESS_INFORMATION pi;
		memset(&pi, 0, sizeof(PROCESS_INFORMATION));

		char *terminal = getenv("COMSPEC");
		if (terminal)
			CreateProcess(NULL, terminal, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
		return RC_HOOK;
//	}
//	return RC_DO_NOTHING;
}
