// xkeymacs.h: interface for the CXkeymacsDll class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XKEYMACS_H__88552DEC_1233_4A0A_BE62_9EF7BC618EC6__INCLUDED_)
#define AFX_XKEYMACS_H__88552DEC_1233_4A0A_BE62_9EF7BC618EC6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

HINSTANCE GetThisHInst();

enum {MAX_APP = 64};
enum {NONE_FOO, NONE_SHIFT_FOO, CONTROL_FOO, CONTROL_SHIFT_FOO, CONTROLX_FOO, CONTROLX_SHIFT_FOO,
	  CONTROLX_CONTROL_FOO, CONTROLX_CONTROL_SHIFT_FOO, META_FOO, META_SHIFT_FOO, MAX_COMMAND_TYPE};
enum {MAX_KEY = 256};
enum KeyTransition {KEY_UP, KEY_DOWN, KEY_TRANSITION};

enum {WINDOW_NAME_LENGTH	= 128};
enum {CLASS_NAME_LENGTH		= 128};
enum {SUB_KEY_NAME_LENGTH	= 128};

enum ReturnCode {RC_DO_NOTHING, RC_HOOK, RC_HOOK0_9, RC_HOOKX, RC_RECURSIVE};
enum SearchDirection {NA, FORWARD, BACKWARD};

// for keystroke-message information
// REPEAT_COUNT:Specifies the repeat count. The value is the number of times the keystroke is repeated as a result of the user's holding down the key.
// EXTENDED_KEY:Specifies whether the key is an extended key, such as a function key or a key on the numeric keypad. The value is 1 if the key is an extended key; otherwise, it is 0.
// CONTEXT_CODE:Specifies the context code. The value is 1 if the ALT key is down; otherwise, it is 0.
// PREVIOUS:	Specifies the previous key state. The value is 1 if the key is down before the message is sent; it is 0 if the key is up.
// TRANSITION:	Specifies the transition state. The value is 0 if the key is being pressed and 1 if it is being released.
enum {REPEAT_COUNT = 0xFFFF, EXTENDED_KEY = 0x1000000,
	  CONTEXT_CODE = 0x20000000, PREVIOUS = 0x40000000, TRANSITION = 0x80000000};

class CSearchKey {
public:
	CSearchKey();
	CSearchKey(char* szApplicationName, int nApplicationNameLength, CString *szDialogTitle);
	BYTE m_bFindWhat;
	BYTE m_bDirectionForward;
	BYTE m_bDirectionBackward;
	BYTE m_bSearchOption;
};

class CSearch {
public:
	CSearch(char* szApplicationName, int nApplicationNameLength);
	CString m_szDialogTitle;
	CSearchKey* m_pKey;
};

class AFX_EXT_CLASS CXkeymacsDll  
{
public:
	void UpdateData();
	void Clear(int nApp);
	BOOL IsKeyboardHook();
	void SetEnable(int nApp, int nCommandType, int nKey, int nEnable);
	void SetApplicationName(int nApp, CString szApplicationName);
	BOOL ReleaseKeyboardHook();
	BOOL SetKeyboardHook();
	CXkeymacsDll();
	virtual ~CXkeymacsDll();

private:
	static BOOL IsMeta(int nApp);
	static BOOL IsDown(BYTE bVk);
//	static BOOL M_Foo(WPARAM wParam, int m_nRepeat, BOOL *bOriginalM_b, BOOL *bOriginalM_f);
//	static BOOL M_Foo(WPARAM wParam, int m_nRepeat);
	static BOOL SetClipboardText(CString *szClipboardText);
	static BOOL CopyBackCharacter();
	static BOOL CopyNextCharacter();
	static BOOL GetClipboardText(CString *szClipboardText);
	static void ToggleIME(char *szApplicationName, int nApplicationNameLength);
	static void DoKeybd_event(BYTE bVk, DWORD dwFlags, LPARAM lParam);
	static void DepressKey(BYTE bVk, LPARAM lParam);
	static void ReleaseKey(BYTE bVk, LPARAM lParam);
	static void Kdu(BYTE bVk, int n);
	static void AdKduAu(BYTE bVk);
	static void AdKduKduAu(BYTE bVk1, BYTE bVk2);
	static void AdKduKduKduAu(BYTE bVk1, BYTE bVk2, BYTE bVk3);
	static void SdKduSu(BYTE bVk);
	static void SdKduKduSu(BYTE bVk1, BYTE bVk2);
	static void CdKduCu(BYTE bVk, int n);
	static LRESULT CALLBACK KeyboardProc(int code, WPARAM wParam, LPARAM lParam);
	static LRESULT CALLBACK CallWndProc(int code, WPARAM wParam, LPARAM lParam);
	static HHOOK m_hHookKeyboard;
	static HHOOK m_hHookCallWnd;
	static BOOL m_bImeComposition;
protected:
	static BOOL m_bJack;
	static ReturnCode MetaPrefixAndOriginal(LPARAM lParam, char *szApplicationName);
	static void CdKdoruCu(BYTE bVk, LPARAM lParam, int n);
	static ReturnCode Meta(LPARAM lParam, char *szApplicationName);
	static ReturnCode ShellCommand(LPARAM lParam, char *szApplicationName);
	static ReturnCode EndOfBuffer(LPARAM lParam, char *szApplicationName);
	static ReturnCode BeginningOfBuffer(LPARAM lParam, char *szApplicationName);
	static ReturnCode KillRingSave(LPARAM lParam, char *szApplicationName);
	static ReturnCode ScrollDown(LPARAM lParam, char *szApplicationName);
	static ReturnCode ForwardWord(LPARAM lParam, char *szApplicationName);
	static ReturnCode BackwardWord(LPARAM lParam, char *szApplicationName);
	static ReturnCode WriteFile(LPARAM lParam, char *szApplicationName);
	static ReturnCode SaveBuffer(LPARAM lParam, char *szApplicationName);
	static ReturnCode MarkPage(LPARAM lParam, char* szApplicationName);
	static ReturnCode FindFile(LPARAM lParam, char *szApplicationName);
	static ReturnCode SaveBuffersKillEmacs(LPARAM lParam, char *szApplicationName);
	static ReturnCode DigitArgument0(LPARAM lParam, char *szApplicationName);
	static ReturnCode DigitArgument1(LPARAM lParam, char *szApplicationName);
	static ReturnCode DigitArgument2(LPARAM lParam, char *szApplicationName);
	static ReturnCode DigitArgument3(LPARAM lParam, char *szApplicationName);
	static ReturnCode DigitArgument4(LPARAM lParam, char *szApplicationName);
	static ReturnCode DigitArgument5(LPARAM lParam, char *szApplicationName);
	static ReturnCode DigitArgument6(LPARAM lParam, char *szApplicationName);
	static ReturnCode DigitArgument7(LPARAM lParam, char *szApplicationName);
	static ReturnCode DigitArgument8(LPARAM lParam, char *szApplicationName);
	static ReturnCode DigitArgument9(LPARAM lParam, char *szApplicationName);
	static ReturnCode DigitArgument(int n);
	static ReturnCode Undo(LPARAM lParam, char *szApplicationName);
	static ReturnCode MetaPrefix(LPARAM lParam, char *szApplicationName);
	static ReturnCode SetMarkCommand(LPARAM lParam, char *szApplicationName);
	static ReturnCode Tab(LPARAM lParam, char *szApplicationName);
	static ReturnCode IconifyOrDeiconifyFrame(LPARAM lParam, char *szApplicationName);
	static ReturnCode Yank(LPARAM lParam, char *szApplicationName);
	static ReturnCode ControlXPrefix(LPARAM lParam, char *szApplicationName);
	static ReturnCode KillRegion(LPARAM lParam, char *szApplicationName);
	static ReturnCode ScrollUp(LPARAM lParam, char *szApplicationName);
	static ReturnCode TransposeChars(LPARAM lParam, char *szApplicationName);
	static ReturnCode IsearchForward(LPARAM lParam, char *szApplicationName);
	static ReturnCode IsearchBackward(LPARAM lParam, char *szApplicationName);
	static ReturnCode PreviousLine(LPARAM lParam, char *szApplicationName);
	static ReturnCode ToggleWin32imeMode(LPARAM lParam, char *szApplicationName);
	static ReturnCode NextLine(LPARAM lParam, char *szApplicationName);
	static ReturnCode Newline(LPARAM lParam, char *szApplicationName);
	static ReturnCode Recenter(LPARAM lParam, char *szApplicationName);
	static ReturnCode KillLine(LPARAM lParam, char *szApplicationName);
	static ReturnCode BackwardDeleteChar(LPARAM lParam, char *szApplicationName);
	static ReturnCode KeyboardQuit(LPARAM lParam, char *szApplicationName);
	static ReturnCode ForwardChar(LPARAM lParam, char *szApplicationName);
	static ReturnCode EndOfLine(LPARAM lParam, char *szApplicationName);
	static ReturnCode DeleteChar(LPARAM lParam, char *szApplicationName);
	static ReturnCode BackwardChar(LPARAM lParam, char *szApplicationName);
	static ReturnCode BeginningOfLine(LPARAM lParam, char *szApplicationName);
	static void Kdoru(BYTE bVk, LPARAM lParam, int n);
	static ReturnCode DoCommand(int nCommandID, LPARAM lParam, char *szApplicationName);
	static int m_nRepeat;
	static BOOL m_bOriginal[MAX_KEY][KEY_TRANSITION];
	static BOOL m_bM_;
	static BOOL m_bC_x;
	static BOOL m_bMeta;
	static BOOL m_bShift;
	static BOOL m_bAlt;
	static BOOL m_bControl;
	static BOOL m_bRightShift;
	static BOOL m_bRightAlt;
	static BOOL m_bRightControl;
	static SearchDirection m_CurrentDirection;
	static void SearchSetDirection(SearchDirection direction, char *szApplicationName, 
								   int nApplicationNameLength, CSearch* pSearch);
	static void Search(SearchDirection direction, char *szApplicationName, int nApplicationNameLength);
	static OSVERSIONINFO m_OsVersionInfo;
	static HWND m_hPrevWnd;
	static char m_szSpecialApp[MAX_APP][CLASS_NAME_LENGTH];
	static int m_nEnable[MAX_APP][MAX_COMMAND_TYPE][MAX_KEY];
	static HWND GetFocusRoot();
};


class AFX_EXT_CLASS CXkeymacsData  
{
public:
	CString GetApplicationTitle();
	void SetApplicationTitle(LPCTSTR lpszApplicationTitle);
	void ClearAll();
	int GetEnable(int nCommandType, int nKey);
	void SetEnable(int nCommandType, int nKey, int nEnable);
	CString GetApplicationName();
	void SetApplicationName(LPCTSTR lpszApplicationName);
	CXkeymacsData();
	virtual ~CXkeymacsData();

protected:
	CString m_strApplicationTitle;
	CString m_strApplicationName;
	int m_nEnable[MAX_COMMAND_TYPE][MAX_KEY];
};

#endif // !defined(AFX_XKEYMACS_H__88552DEC_1233_4A0A_BE62_9EF7BC618EC6__INCLUDED_)
